
IF OBJECT_ID(N'PK4_6') IS NOT NULL
ALTER TABLE [dbo].[perfil_centro] DROP CONSTRAINT [PK4_6] 

GO

if exists (SELECT distinct(c.name)  
                  FROM dbo.SYSCOLUMNS C  
                  INNER JOIN dbo.SYSOBJECTS T   
                  ON C.[ID] = T.[ID]   
                  WHERE T.XTYPE = 'U'   
                  and t.name='perfiles'   
                  and c.name='empresas')  
  ALTER TABLE perfiles alter column empresas varchar(650) NULL 
go  

if exists (SELECT * 
    FROM INFORMATION_SCHEMA.TABLE_CONSTRAINTS
    WHERE CONSTRAINT_NAME='PK7_4' )

ALTER TABLE [dbo].[opciones] drop CONSTRAINT PK7_4
GO


if exists (SELECT distinct(c.name)  
                  FROM dbo.SYSCOLUMNS C  
                  INNER JOIN dbo.SYSOBJECTS T   
                  ON C.[ID] = T.[ID]   
                  WHERE T.XTYPE = 'U'   
                  and t.name='opciones'   
                  and c.name='opcion')  
  ALTER TABLE opciones alter column opcion char(3) null  
go  

if exists (SELECT * 
    FROM INFORMATION_SCHEMA.TABLE_CONSTRAINTS
    WHERE CONSTRAINT_NAME='PK8_3' )

ALTER TABLE [dbo].perfil_funcion drop CONSTRAINT PK8_3
GO

if exists (SELECT distinct(c.name)  
                  FROM dbo.SYSCOLUMNS C  
                  INNER JOIN dbo.SYSOBJECTS T   
                  ON C.[ID] = T.[ID]   
                  WHERE T.XTYPE = 'U'   
                  and t.name='perfil_funcion'   
                  and c.name='opcion')  
  ALTER TABLE perfil_funcion alter column opcion char(3) NULL 
go  


if exists (SELECT distinct(c.name)  
                  FROM dbo.SYSCOLUMNS C  
                  INNER JOIN dbo.SYSOBJECTS T   
                  ON C.[ID] = T.[ID]   
                  WHERE T.XTYPE = 'U'   
                  and t.name='perfiles'   
                  and c.name='nomina')  
  ALTER TABLE perfiles alter column nomina varchar(150) NULL 
go 

if exists (SELECT distinct(c.name)  
                  FROM dbo.SYSCOLUMNS C  
                  INNER JOIN dbo.SYSOBJECTS T   
                  ON C.[ID] = T.[ID]   
                  WHERE T.XTYPE = 'U'   
                  and t.name='perfiles'   
                  and c.name='descripcion')  
  ALTER TABLE perfiles alter column descripcion varchar(150) NULL 
go 


IF not EXISTS(select syscolumns.name  from syscolumns 
left join sysobjects on syscolumns.id=sysobjects.id
where syscolumns.name = 'email' and sysobjects.name='usuarios')
Alter table usuarios add email varchar(250) null    
              
go

IF OBJECT_ID(N'dbo.AccesoaFunciones') IS NOT NULL 
    DROP FUNCTION dbo.AccesoaFunciones
GO

CREATE FUNCTION dbo.AccesoaFunciones ( @idperfil INT )
RETURNS VARCHAR(500)
AS 
    BEGIN
        DECLARE @cfunciones VARCHAR(500)
        DECLARE @cfuncion VARCHAR(5)
        SET @cfunciones = ''
        DECLARE funcionesCursor CURSOR FOR
        SELECT DISTINCT(RTRIM(z.funcion)+',') FROM perfil_funcion AS Z WHERE @idperfil=Z.idperfil
        OPEN funcionesCursor
        FETCH NEXT FROM funcionesCursor
  INTO @cfuncion
        WHILE @@fetch_status = 0 
            BEGIN
                SET @cfunciones = @cfunciones + @cfuncion
                FETCH NEXT FROM funcionesCursor
		INTO @cfuncion
            END
        CLOSE funcionesCursor
        DEALLOCATE funcionesCursor	
        RETURN @cfunciones 
    END
GO


IF OBJECT_ID(N'dbo.AccesoaOpciones') IS NOT NULL 
    DROP FUNCTION dbo.AccesoaOpciones
GO

CREATE FUNCTION dbo.AccesoaOpciones
    (
      @sistema VARCHAR(5) ,
      @usuario VARCHAR(30) ,
      @funcion VARCHAR(5)
    )
RETURNS VARCHAR(500)
AS 
    BEGIN
        DECLARE @cOpciones VARCHAR(500)
        DECLARE @cOpcion VARCHAR(5)
        SET @cOpciones = ''
        DECLARE OpcionesCursor CURSOR FOR
        SELECT c.opcion+ ','  FROM perfiles AS a
        LEFT JOIN perfil_usuarios AS b ON a.idperfil=b.idperfil
        LEFT JOIN perfil_funcion AS c ON b.idperfil=c.idperfil
        WHERE a.sistema=@sistema AND b.usuario=@usuario AND c.funcion=@funcion
        OPEN OpcionesCursor
        FETCH NEXT FROM OpcionesCursor
  INTO @cOpcion
        WHILE @@fetch_status = 0 
            BEGIN
                SET @cOpciones = @cOpciones + @cOpcion
                FETCH NEXT FROM OpcionesCursor
		INTO @cOpcion
            END
        CLOSE OpcionesCursor
        DEALLOCATE OpcionesCursor
        RETURN @cOpciones 
    END
GO

IF not EXISTS(select syscolumns.name  from syscolumns
left join sysobjects on syscolumns.id= sysobjects.id
where syscolumns.name = 'empresa' and sysobjects.name='perfil_centro')
Alter table perfil_centro add empresa bigint null

Go

if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[perfil_reporte]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)  
CREATE TABLE [dbo].[perfil_reporte](
	[reporte] [varchar](100) NULL,
	[idPerfil] [bigint] NULL,
	[empresa] [bigint] NULL
) ON [PRIMARY]

GO

if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[perfil_tipoNomina]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)  
CREATE TABLE [dbo].[perfil_tipoNomina](
	[idPerfil] [bigint] NOT NULL,
	[tipoNom] [int] NOT NULL,
 CONSTRAINT [PK_perfil_tipoNomina] PRIMARY KEY CLUSTERED 
(
	[idPerfil] ASC,
	[tipoNom] ASC
)
) ON [PRIMARY]
GO

if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Perfil_empresa]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)  
CREATE TABLE [dbo].[Perfil_empresa](
	[idPerfil] [bigint] NOT NULL,
	[idEmpresa] [bigint] NOT NULL,
 CONSTRAINT [PK_Perfil_empresa] PRIMARY KEY CLUSTERED 
(
	[idPerfil] ASC,
	[idEmpresa] ASC
)
) ON [PRIMARY]
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosValidaEmpresaCentro'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosValidaEmpresaCentro
GO

CREATE PROCEDURE dbo.usuariosValidaEmpresaCentro

AS 
    
    SET NOCOUNT ON
    SET DATEFORMAT MDY   
    
    declare @vcentro as varchar(50)
    declare @vIdPerfil as bigint
    declare @vIdEmpresa as bigint
	
	DECLARE Centro_cursor CURSOR FOR 
	select centro, idperfil
	from perfil_centro
	where empresa is null
	
	OPEN Centro_cursor
	FETCH NEXT FROM Centro_cursor INTO @vcentro,@vidperfil
	WHILE @@FETCH_STATUS = 0
	BEGIN
	
		set @vIdEmpresa = 0
		
		select @vIdEmpresa=empresa
		from centros	
		where centro=@vcentro
		
		if @vIdEmpresa<>0
			begin
				update perfil_centro
				set empresa=@vIdEmpresa
				where centro=@vcentro
				and idperfil=@vIdPerfil
			end
		

		FETCH NEXT FROM Centro_cursor INTO @vcentro,@vidperfil
	END    
	DEALLOCATE Centro_cursor
go

exec usuariosValidaEmpresaCentro

go


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'userList'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.userList
GO

CREATE PROCEDURE [dbo].userList
    @usuario VARCHAR(20)
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
	
	if @usuario=''
		Select usuario, descripcion, convert(varchar(10),expiracion,103),email from usuarios
	else
		Select usuario, descripcion, convert(varchar(10),expiracion,103),email from usuarios
		where usuario=@usuario	
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'userPasswordLength'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.userPasswordLength
GO

CREATE PROCEDURE dbo.userPasswordLength

AS
SET NOCOUNT ON
SET DATEFORMAT MDY

Select longitud_password from ctrl_usuarios

go

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'userDelete'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.userDelete
GO
create PROCEDURE dbo.userDelete
@usuario VARCHAR(20)
AS
SET NOCOUNT ON
SET DATEFORMAT MDY

delete from hpwd where usuario=@usuario
delete from perfil_usuarios where usuario=@usuario
Delete from usuarios where usuario=@usuario
go

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosPerfilesAsignadosAUsuarios'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosPerfilesAsignadosAUsuarios
GO

create PROCEDURE dbo.usuariosPerfilesAsignadosAUsuarios
( @idUsuario varchar(30))
AS
BEGIN 
	Select  sistema.nombre, 
			perfil_usuarios.idPerfil, 
			perfiles.Descripcion  
	from perfil_usuarios 
		left join  perfiles on perfil_usuarios.idperfil=perfiles.idperfil
		left join Sistema on perfiles.sistema=sistema.sistema			
	where usuario=@idusuario 
END
            
go 
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosCargaReglasCambioUsuario'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosCargaReglasCambioUsuario
GO
create PROCEDURE dbo.usuariosCargaReglasCambioUsuario
AS
BEGIN 
	SELECT Dias_vigencia
		  ,Longitud_password
		  ,Rotacion_password
		  ,Requiere_numeros
		  ,Dias_aviso
		  ,especiales
		  ,mayusculas
		  ,minusculas
    from ctrl_usuarios
END
            
go            



IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosRotacionPassword'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosRotacionPassword
GO
create PROCEDURE dbo.usuariosRotacionPassword
(@usuario VARCHAR(20),
 @password varchar(30))
AS
BEGIN 

	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY
    
    declare @result  int = 0
    declare @rotacion  decimal(9,0)
    declare @veces  int = 0
    declare @top varchar(500)
    
    create table #ResutadoTemporal
		(vpassword varchar(20),
		 numero int)
	
	select @rotacion = isnull(Rotacion_password,0)
	from Ctrl_usuarios 
	
	set @top = ' select Top ' + CONVERT(varchar(15),@rotacion) + ' password, count(*)' +
			   ' from hpwd ' + 
			   ' where usuario=''' + @usuario + '''' +
			   ' and password=''' + @password + '''' +
			   ' group by password'
	
	insert into #ResutadoTemporal exec (@top)
	
	select numero as numero from #ResutadoTemporal
		
END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 
end
GO
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosListaPerfiles'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosListaPerfiles
GO
create PROCEDURE dbo.usuariosListaPerfiles

AS
BEGIN 
	Select  sistema.nombre, 
			perfil_usuarios.idPerfil, 
			perfiles.Descripcion  
	from perfil_usuarios 
		left join  perfiles on perfil_usuarios.idperfil=perfiles.idperfil
		left join Sistema on perfiles.sistema=sistema.sistema			
	
END
            
go    

IF not EXISTS(select syscolumns.name  from syscolumns 
left join sysobjects on syscolumns.id=sysobjects.id
where syscolumns.name = 'especiales' and sysobjects.name='Ctrl_usuarios')
Alter table Ctrl_usuarios add especiales numeric(2,0) null    
              
go

IF not EXISTS(select syscolumns.name  from syscolumns 
left join sysobjects on syscolumns.id=sysobjects.id
where syscolumns.name = 'mayusculas' and sysobjects.name='Ctrl_usuarios')
Alter table Ctrl_usuarios add mayusculas numeric(2,0) null    
              
go


IF not EXISTS(select syscolumns.name  from syscolumns 
left join sysobjects on syscolumns.id=sysobjects.id
where syscolumns.name = 'minusculas' and sysobjects.name='Ctrl_usuarios')
Alter table Ctrl_usuarios add minusculas numeric(2,0) null    
              
go


UPDATE Ctrl_usuarios set especiales=0 where especiales is null
UPDATE Ctrl_usuarios set mayusculas=0 where mayusculas is null
UPDATE Ctrl_usuarios set minusculas=0 where minusculas is null
go


IF not EXISTS(select syscolumns.name from syscolumns 
					left join sysobjects on syscolumns.id=sysobjects.id
					where syscolumns.name = 'descripcion' and sysobjects.name='perfiles') 
	alter table perfiles alter column descripcion varchar(250)
GO
	
	if not exists( select sistema from Sistema where sistema='PP' )
		insert into Sistema values ('PP','Administrador Portal del Patron')
GO
	
	IF NOT EXISTS (SELECT * FROM funciones WHERE Sistema='PP' AND FUNCION='A' AND descripcion='Informe Ejecutivo Nomina' )
		INSERT INTO funciones(sistema,funcion,descripcion) VALUES  ('PP','A','Informe Ejecutivo Nomina')

	IF NOT EXISTS (SELECT * FROM funciones WHERE Sistema='PP' AND FUNCION='B' AND descripcion='Informe Ejecutivo Otros' )		
		INSERT INTO funciones(sistema,funcion,descripcion) VALUES  ('PP','B','Informe Ejecutivo Otros')
	
	IF NOT EXISTS (SELECT * FROM funciones WHERE Sistema='PP' AND FUNCION='C' AND descripcion='Pasivo Laboral' )
		INSERT INTO funciones(sistema,funcion,descripcion) VALUES  ('PP','C','Pasivo Laboral')
	
	IF NOT EXISTS (SELECT * FROM funciones WHERE Sistema='PP' AND FUNCION='D' AND descripcion='Reportes Varios' )
		INSERT INTO funciones(sistema,funcion,descripcion) VALUES  ('PP','D','Reportes Varios')
	
	IF NOT EXISTS (SELECT * FROM funciones WHERE Sistema='PP' AND FUNCION='E' AND descripcion='Indices y Estadisticas' )
		INSERT INTO funciones(sistema,funcion,descripcion) VALUES  ('PP','E','Indices y Estadisticas')
	
	IF NOT EXISTS (SELECT * FROM funciones WHERE Sistema='PP' AND FUNCION='F' AND descripcion='Horas Laboradas' )
		INSERT INTO funciones(sistema,funcion,descripcion) VALUES  ('PP','F','Horas Laboradas')
	
	IF NOT EXISTS (SELECT * FROM funciones WHERE Sistema='PP' AND FUNCION='G' AND descripcion='Utilerias Portales' )
		INSERT INTO funciones(sistema,funcion,descripcion) VALUES  ('PP','G','Utilerias Portales')
	
	IF NOT EXISTS (SELECT * FROM funciones WHERE Sistema='PP' AND FUNCION='H' AND descripcion='Historico Movimientos' )
		INSERT INTO funciones(sistema,funcion,descripcion) VALUES  ('PP','H','Historico Movimientos')
	
	IF NOT EXISTS (SELECT * FROM funciones WHERE Sistema='PP' AND FUNCION='I' AND descripcion='Historico de Incidencias' )
		INSERT INTO funciones(sistema,funcion,descripcion) VALUES  ('PP','I','Historico de Incidencias')
	
	IF NOT EXISTS (SELECT * FROM funciones WHERE Sistema='PP' AND FUNCION='J' AND descripcion='Auditoria de Sueldos' )
		INSERT INTO funciones(sistema,funcion,descripcion) VALUES  ('PP','J','Auditoria de Sueldos')
	
	IF NOT EXISTS (SELECT * FROM funciones WHERE Sistema='PP' AND FUNCION='K' AND descripcion='Recibos de Nomina' )
		INSERT INTO funciones(sistema,funcion,descripcion) VALUES  ('PP','K','Recibos de Nomina')
	
	IF NOT EXISTS (SELECT * FROM funciones WHERE Sistema='PP' AND FUNCION='L' AND descripcion='Kardex' )
		INSERT INTO funciones(sistema,funcion,descripcion) VALUES  ('PP','L','Kardex')
		
	IF NOT EXISTS (SELECT * FROM funciones WHERE Sistema='PP' AND FUNCION='M' AND descripcion='Excedentes IMSS' )	
		INSERT INTO funciones(sistema,funcion,descripcion) VALUES  ('PP','M','Excedentes IMSS')
GO		
	
	IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='PP' AND FUNCION='A' and opcion='A1' AND descripcion='Informe Ejecutivo Nomina' )	
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('A1','PP','A','Informe Ejecutivo Nomina')
	
	IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='PP' AND FUNCION='B' and opcion='B1' AND descripcion='Informe Ejecutivo Otros' )	
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('B1','PP','B','Informe Ejecutivo Otros')
	
	IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='PP' AND FUNCION='C' and opcion='C1' AND descripcion='pasivo Laboral' )	
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('C1','PP','C','Pasivo Laboral')
	
	IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='PP' AND FUNCION='D' and opcion='D1' AND descripcion='Reportes Varios' )	
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('D1','PP','D','Reportes Varios')
	
	IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='PP' AND FUNCION='E' and opcion='E1' AND descripcion='Indices y Estadisticas' )	
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('E1','PP','E','Indices y Estadisticas')
	
	IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='PP' AND FUNCION='F' and opcion='F1' AND descripcion='Horas Laboradas' )	
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('F1','PP','F','Horas Laboradas')
	
	IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='PP' AND FUNCION='G' and opcion='G1' AND descripcion='Utilerias Portales' )	
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('G1','PP','G','Utilerias Portales')
	
	IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='PP' AND FUNCION='H' and opcion='H1' AND descripcion='Historico Movimientos' )	
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('H1','PP','H','Historico Movimientos')
	
	IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='PP' AND FUNCION='I' and opcion='I1' AND descripcion='Historico de Incidencias' )	
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('I1','PP','I','Historico de Incidencias')
		
	IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='PP' AND FUNCION='J' and opcion='J1' AND descripcion='Auditoria de Sueldos' )	
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('J1','PP','J','Auditoria de Sueldos')
	
	IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='PP' AND FUNCION='K' and opcion='K1' AND descripcion='Recibos de Nomina' )	
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('K1','PP','K','Recibos de Nomina')
	
	IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='PP' AND FUNCION='L' and opcion='L1' AND descripcion='Kardex' )	
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('L1','PP','L','Kardex')
	
	IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='PP' AND FUNCION='M' and opcion='M1' AND descripcion='Excedentes IMSS' )	
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('M1','PP','M','Excedentes IMSS')
		
GO		

IF NOT EXISTS (SELECT * FROM perfiles WHERE descripcion='Administrador Portal del Patron' )	
insert into perfiles values ('Administrador Portal del Patron','PP','{}','{}','N','N',null) 
go


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'insertaPermisosAdministradorPortalPatron'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.insertaPermisosAdministradorPortalPatron
GO
create PROCEDURE dbo.insertaPermisosAdministradorPortalPatron

AS
BEGIN 

	declare @idperfil as bigint
	declare @cantidad as bigint
	
	SELECT @idperfil=idperfil FROM perfiles WHERE upper(descripcion)='ADMINISTRADOR PORTAL DEL PATRON' or UPPER(descripcion)='ADMIN. PORTAL DEL PATRON'
	
	if @idperfil>0	
		IF NOT EXISTS (	select idperfil from perfil_usuarios where idperfil=@idperfil and usuario='administrador' )
		insert into perfil_usuarios values (@idperfil,'administrador')	

END
            
go 

exec insertaPermisosAdministradorPortalPatron
go


IF not EXISTS (SELECT * FROM sistema WHERE Sistema='TP')	
	insert into Sistema (sistema, nombre) values ('TP','PORTAL DEL TRABAJADOR')
go
IF not EXISTS (SELECT * FROM sistema WHERE Sistema='AS')	
	insert into Sistema (sistema, nombre) values ('AS','ASISTENTIS-SAR')
go
IF not EXISTS (SELECT * FROM sistema WHERE Sistema='PP')	
	insert into Sistema (sistema, nombre) values ('PP','PORTAL DEL PATRON')
go
IF not EXISTS (SELECT * FROM sistema WHERE Sistema='PL')	
	insert into Sistema (sistema, nombre) values ('PL','PLANTILLAS')
go

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'insertaPermisosReportesAPerfilesExistentes'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.insertaPermisosReportesAPerfilesExistentes
GO
create PROCEDURE dbo.insertaPermisosReportesAPerfilesExistentes

AS
BEGIN 

	declare @existePermiso int
	
	select @existePermiso=count(idperfil)
	from perfil_funcion
	where idperfil in (select idperfil from perfiles where sistema='TP')
	and funcion='R' and opcion='R2'
	
	if @existePermiso=0
		begin
			insert into perfil_funcion 
			select 'R','R2', idperfil from perfiles where sistema='TP'
			
			insert into perfil_funcion 
			select 'R','R3', idperfil from perfiles where sistema='TP'
			
			insert into perfil_funcion 
			select 'R','R4', idperfil from perfiles where sistema='TP'
			
			insert into perfil_funcion 
			select 'R','R5', idperfil from perfiles where sistema='TP'
			
			insert into perfil_funcion 
			select 'R','R6', idperfil from perfiles where sistema='TP'
			
			insert into perfil_funcion 
			select 'R','R7', idperfil from perfiles where sistema='TP'
			
			insert into perfil_funcion 
			select 'R','R8', idperfil from perfiles where sistema='TP'
			
			insert into perfil_funcion 
			select 'R','R9', idperfil from perfiles where sistema='TP'
			
			insert into perfil_funcion 
			select 'R','R10', idperfil from perfiles where sistema='TP'
			
			insert into perfil_funcion 
			select 'A','A3', idperfil from perfiles where sistema='TP'
		end

END
            
go 

exec insertaPermisosReportesAPerfilesExistentes
go

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'obtenListadoDeBasesDeDatos'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.obtenListadoDeBasesDeDatos
GO
create PROCEDURE dbo.obtenListadoDeBasesDeDatos

AS
BEGIN 

	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY
		
		declare @basesDeDatos as table(name varchar(500),id bigint)

		insert into @basesDeDatos
		SELECT	name, 
				DENSE_RANK() OVER (PARTITION BY 1 ORDER BY name ASC) as id
				--database_id, create_date
		FROM sys.databases

		declare @max bigint = (select max(id) from @basesDeDatos)
		declare @conta bigint = 1
		declare @Base varchar(500)
		declare @sql varchar(max)
		declare @respuesta int
		declare @bases as table(valida bigint,name varchar(500))

		while @conta<=@max
		begin
			set @Base = (select name from @basesDeDatos where id=@conta)
			set @sql = 'select isnull((SELECT 1 FROM '+@base+'.INFORMATION_SCHEMA.TABLES where table_name = ''avisos_imss''),0),'''+@base+''''--'IF EXISTS ( SELECT  name FROM    dbo.sysobjects WHERE   id = OBJECT_ID(N''['+@base+'].[dbo].[avisos_imss]'') AND OBJECTPROPERTY(id, N''IsUserTable'') = 1 ) begin select 1,'''+@base+''' end else begin select 0,'''+@base+''' end' 
	
			insert into @bases
			exec(@sql)
	
			set @conta+=1
		end

		select * 
		from @bases
		where valida=1
		
END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 
end
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosCargaPerfil'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosCargaPerfil
GO
create PROCEDURE dbo.usuariosCargaPerfil
(@usuario VARCHAR(20),
 @sistema char(2))
AS

BEGIN 

	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY
    
	SELECT  perfiles.idperfil, 
			perfiles.empresas, 
			perfiles.nomina, 
			perfiles.actualizar, 
			perfiles.sueldo
	FROM perfil_usuarios 
		left join perfiles on perfiles.idperfil=perfil_usuarios.idperfil
	WHERE perfil_usuarios.usuario=@usuario
		and perfiles.sistema=@sistema

	END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 

END
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosCargaFuncionesOpcionesPorPerfil'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosCargaFuncionesOpcionesPorPerfil
GO
create PROCEDURE dbo.usuariosCargaFuncionesOpcionesPorPerfil
(@idperfil bigint)
AS

BEGIN 

	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY
    
	select perfil_funcion.funcion, perfil_funcion.opcion 
	from perfiles
	left join perfil_funcion on perfiles.idperfil=perfil_funcion.idperfil
	where perfiles.idperfil=@idperfil
	order by perfil_funcion.funcion

	END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 

END
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosCargaEmpresas'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosCargaEmpresas
GO
create PROCEDURE dbo.usuariosCargaEmpresas
(@usuario VARCHAR(20),
@idPerfil bigint)
AS

BEGIN 

	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY
    
		declare @stringEmpresas varchar(500)
		declare @select varchar (1000)
		declare @from varchar(500)
		declare @where varchar(max)
		
		set @select= ' select empresa, nombre_empresa, isnull(referencia,'''')'
		set @from= ' from empresas'
		set @where= ' '
	    
		Select @stringEmpresas = perfiles.empresas 
		from usuarios
			left join perfil_usuarios on usuarios.usuario=perfil_usuarios.usuario
			left join perfiles on  perfil_usuarios.idperfil=perfiles.idperfil
		where usuarios.usuario= @usuario  
		and perfiles.idperfil=@idPerfil
	    
		set @stringEmpresas=SUBSTRING(@stringempresas,2,len(@stringEmpresas)-2)
		
		if len(@stringEmpresas)>0
			set @where = ' where empresa in (' + @stringEmpresas + ')'
		
		exec (@select + @from + @where)

	END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 

END
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosCambiarPassword'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosCambiarPassword
GO
create PROCEDURE dbo.usuariosCambiarPassword
(@usuario VARCHAR(20),
 @password varchar(30))
AS
BEGIN 

	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY
		
	update usuarios set password=@password, 
	expiracion = expiracion + (select isnull(Dias_vigencia,0) from Ctrl_usuarios)
	where usuario=@usuario
	
	insert into hpwd(usuario, fch_modifico, password) 
	values (@usuario,getdate(),@password)
		
END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 
end
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'obtenListadoDeBasesDeDatos'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.obtenListadoDeBasesDeDatos
GO
create PROCEDURE dbo.obtenListadoDeBasesDeDatos

AS
BEGIN 

	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY
		
		declare @basesDeDatos as table(name varchar(500),id bigint)

		insert into @basesDeDatos
		SELECT	name, 
				DENSE_RANK() OVER (PARTITION BY 1 ORDER BY name ASC) as id
				--database_id, create_date
		FROM sys.databases

		declare @max bigint = (select max(id) from @basesDeDatos)
		declare @conta bigint = 1
		declare @Base varchar(500)
		declare @sql varchar(max)
		declare @respuesta int
		declare @bases as table(valida bigint,name varchar(500))

		while @conta<=@max
		begin
			set @Base = (select name from @basesDeDatos where id=@conta)
			set @sql = 'select isnull((SELECT 1 FROM '+@base+'.INFORMATION_SCHEMA.TABLES where table_name = ''avisos_imss''),0),'''+@base+''''--'IF EXISTS ( SELECT  name FROM    dbo.sysobjects WHERE   id = OBJECT_ID(N''['+@base+'].[dbo].[avisos_imss]'') AND OBJECTPROPERTY(id, N''IsUserTable'') = 1 ) begin select 1,'''+@base+''' end else begin select 0,'''+@base+''' end' 
	
			insert into @bases
			exec(@sql)
	
			set @conta+=1
		end

		select * 
		from @bases
		where valida=1
		
END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 
end
GO

IF NOT EXISTS ( SELECT  *
                FROM    dbo.syscolumns
                WHERE   id = OBJECT_ID('dbo.Perfiles')
                        AND name = 'PortalEmp' ) 
    ALTER TABLE dbo.Perfiles ADD PortalEmp int
GO

update dbo.perfiles set PortalEmp=1,sueldo='S' where PortalEmp is null and sistema='TP'


GO


--Adn
--20231213
/************************************************************************/
IF not EXISTS(select syscolumns.name  from syscolumns 
left join sysobjects on syscolumns.id=sysobjects.id
where syscolumns.name = 'AutenDosPasos' and sysobjects.name='Ctrl_usuarios')
Alter table dbo.Ctrl_usuarios add AutenDosPasos int null    
              
go

IF not EXISTS(select syscolumns.name  from syscolumns 
left join sysobjects on syscolumns.id=sysobjects.id
where syscolumns.name = 'ServidorDosPasos' and sysobjects.name='Ctrl_usuarios')
Alter table dbo.Ctrl_usuarios add ServidorDosPasos varchar(200) null    
              
go

IF not EXISTS(select syscolumns.name  from syscolumns 
left join sysobjects on syscolumns.id=sysobjects.id
where syscolumns.name = 'VigenciaEnlace' and sysobjects.name='Ctrl_usuarios')
Alter table dbo.Ctrl_usuarios add VigenciaEnlace int null    
              
go

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'WD_DP_BuscaAplicaDosPasos'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.WD_DP_BuscaAplicaDosPasos
GO

CREATE PROCEDURE dbo.WD_DP_BuscaAplicaDosPasos
(
	@Usuario varchar(max)
)

 
    --WITH ENCRYPTION
AS
SET NOCOUNT ON
SET XACT_ABORT ON	
BEGIN TRANSACTION
BEGIN TRY
		
	
	--select * from dbo.Ctrl_usuarios
	select	a.usuario,a.email,b.AutenDosPasos,b.ServidorDosPasos,b.VigenciaEnlace,rtrim(ltrim(c.rfc)) RFC
	from dbo.usuarios as a
	outer apply (	select Top 1 isnull(AutenDosPasos,0) AutenDosPasos,ServidorDosPasos,isnull(VigenciaEnlace,999) VigenciaEnlace
					from dbo.Ctrl_usuarios
				) as b
	outer apply (
					select max(rfc_empresa) as rfc from dbo.empresas
				) as c
	where usuario=@Usuario
	

END TRY

BEGIN CATCH

    IF ( XACT_STATE() ) = -1
        OR @@TRANCOUNT > 0 
        ROLLBACK TRANSACTION
    
    SELECT  ERROR_NUMBER() AS ErrorNumero ,
            ERROR_SEVERITY() AS ErrorSeveridad ,
            ERROR_STATE() AS ErrorEstado ,
            ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedimiento ,
            ERROR_LINE() AS ErrorLinea ,
            ERROR_MESSAGE() AS ErrorMensaje
            
END CATCH

IF @@TRANCOUNT > 0 
    COMMIT TRANSACTION 


GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosExtraeATablaEmpresas'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosExtraeATablaEmpresas
GO

CREATE PROCEDURE dbo.usuariosExtraeATablaEmpresas
 
    --WITH ENCRYPTION
AS
SET NOCOUNT ON
SET XACT_ABORT ON	
BEGIN TRANSACTION
BEGIN TRY
		
	insert into Perfil_empresa
		SELECT idPerfil, value 
		from perfiles
		cross apply STRING_SPLIT(SUBSTRING(empresas,2,LEN(empresas)-2), ',',1)
		WHERE RTRIM(value) <> ''
		and empresas is not null

	--update perfiles set empresas=null

END TRY

BEGIN CATCH

    IF ( XACT_STATE() ) = -1
        OR @@TRANCOUNT > 0 
        ROLLBACK TRANSACTION
    
    SELECT  ERROR_NUMBER() AS ErrorNumero ,
            ERROR_SEVERITY() AS ErrorSeveridad ,
            ERROR_STATE() AS ErrorEstado ,
            ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedimiento ,
            ERROR_LINE() AS ErrorLinea ,
            ERROR_MESSAGE() AS ErrorMensaje
            
END CATCH

IF @@TRANCOUNT > 0 
    COMMIT TRANSACTION 


GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosExtraeATablaTipoNomina'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosExtraeATablaTipoNomina
GO

CREATE PROCEDURE dbo.usuariosExtraeATablaTipoNomina
 
    --WITH ENCRYPTION
AS
SET NOCOUNT ON
SET XACT_ABORT ON	
BEGIN TRANSACTION
BEGIN TRY
		
	insert into perfil_tipoNomina
		SELECT idPerfil, value 
		from perfiles
		cross apply STRING_SPLIT(SUBSTRING(nomina,2,LEN(nomina)-2), ',',1)
		WHERE RTRIM(value) <> ''
		and nomina is not null

	--update perfiles set nomina=null

END TRY

BEGIN CATCH

    IF ( XACT_STATE() ) = -1
        OR @@TRANCOUNT > 0 
        ROLLBACK TRANSACTION
    
    SELECT  ERROR_NUMBER() AS ErrorNumero ,
            ERROR_SEVERITY() AS ErrorSeveridad ,
            ERROR_STATE() AS ErrorEstado ,
            ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedimiento ,
            ERROR_LINE() AS ErrorLinea ,
            ERROR_MESSAGE() AS ErrorMensaje
            
END CATCH

IF @@TRANCOUNT > 0 
    COMMIT TRANSACTION 

GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosComboEmpresas'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosComboEmpresas
GO
create PROCEDURE dbo.usuariosComboEmpresas

AS
BEGIN 

	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY
		
	Select convert(varchar(10),e.empresa) + ' - ' + rtrim(e.nombre_empresa) + ' - '  + rtrim(e.referencia)
	from empresas e
	order by e.empresa
		
END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 
end
GO