IF OBJECT_ID(N'PK4_6') IS NOT NULL
ALTER TABLE [dbo].[perfil_centro] DROP CONSTRAINT [PK4_6] 

GO

if exists (SELECT distinct(c.name)  
                  FROM dbo.SYSCOLUMNS C  
                  INNER JOIN dbo.SYSOBJECTS T   
                  ON C.[ID] = T.[ID]   
                  WHERE T.XTYPE = 'U'   
                  and t.name='perfiles'   
                  and c.name='empresas')  
  ALTER TABLE perfiles alter column empresas varchar(650) NULL 
go  

if exists (SELECT distinct(c.name)  
                  FROM dbo.SYSCOLUMNS C  
                  INNER JOIN dbo.SYSOBJECTS T   
                  ON C.[ID] = T.[ID]   
                  WHERE T.XTYPE = 'U'   
                  and t.name='perfil_centro'   
                  and c.name='centro')  
  ALTER TABLE perfil_centro alter column centro varchar(15) NULL 
go  

if exists (SELECT * 
    FROM INFORMATION_SCHEMA.TABLE_CONSTRAINTS
    WHERE CONSTRAINT_NAME='PK7_4' )

ALTER TABLE [dbo].[opciones] drop CONSTRAINT PK7_4
GO


if exists (SELECT distinct(c.name)  
                  FROM dbo.SYSCOLUMNS C  
                  INNER JOIN dbo.SYSOBJECTS T   
                  ON C.[ID] = T.[ID]   
                  WHERE T.XTYPE = 'U'   
                  and t.name='opciones'   
                  and c.name='opcion')  
  ALTER TABLE opciones alter column opcion char(3) null  
go  

if exists (SELECT * 
    FROM INFORMATION_SCHEMA.TABLE_CONSTRAINTS
    WHERE CONSTRAINT_NAME='PK8_3' )

ALTER TABLE [dbo].perfil_funcion drop CONSTRAINT PK8_3
GO

if exists (SELECT distinct(c.name)  
                  FROM dbo.SYSCOLUMNS C  
                  INNER JOIN dbo.SYSOBJECTS T   
                  ON C.[ID] = T.[ID]   
                  WHERE T.XTYPE = 'U'   
                  and t.name='perfil_funcion'   
                  and c.name='opcion')  
  ALTER TABLE perfil_funcion alter column opcion char(3) NULL 
go  


if exists (SELECT distinct(c.name)  
                  FROM dbo.SYSCOLUMNS C  
                  INNER JOIN dbo.SYSOBJECTS T   
                  ON C.[ID] = T.[ID]   
                  WHERE T.XTYPE = 'U'   
                  and t.name='perfiles'   
                  and c.name='nomina')  
  ALTER TABLE perfiles alter column nomina varchar(150) NULL 
go 

if exists (SELECT distinct(c.name)  
                  FROM dbo.SYSCOLUMNS C  
                  INNER JOIN dbo.SYSOBJECTS T   
                  ON C.[ID] = T.[ID]   
                  WHERE T.XTYPE = 'U'   
                  and t.name='perfiles'   
                  and c.name='descripcion')  
  ALTER TABLE perfiles alter column descripcion varchar(150) NULL 
go 

IF not EXISTS(select syscolumns.name  from syscolumns 
left join sysobjects on syscolumns.id=sysobjects.id
where syscolumns.name = 'email' and sysobjects.name='usuarios')
Alter table usuarios add email varchar(250) null    
              
go

IF OBJECT_ID(N'dbo.AccesoaFunciones') IS NOT NULL 
    DROP FUNCTION dbo.AccesoaFunciones
GO

CREATE FUNCTION dbo.AccesoaFunciones ( @idperfil INT )
RETURNS VARCHAR(500)
AS 
    BEGIN
        DECLARE @cfunciones VARCHAR(500)
        DECLARE @cfuncion VARCHAR(5)
        SET @cfunciones = ''
        DECLARE funcionesCursor CURSOR FOR
        SELECT DISTINCT(RTRIM(z.funcion)+',') FROM perfil_funcion AS Z WHERE @idperfil=Z.idperfil
        OPEN funcionesCursor
        FETCH NEXT FROM funcionesCursor
  INTO @cfuncion
        WHILE @@fetch_status = 0 
            BEGIN
                SET @cfunciones = @cfunciones + @cfuncion
                FETCH NEXT FROM funcionesCursor
		INTO @cfuncion
            END
        CLOSE funcionesCursor
        DEALLOCATE funcionesCursor	
        RETURN @cfunciones 
    END
GO

IF OBJECT_ID(N'dbo.AccesoaOpciones') IS NOT NULL 
    DROP FUNCTION dbo.AccesoaOpciones
GO

CREATE FUNCTION dbo.AccesoaOpciones
    (
      @sistema VARCHAR(5) ,
      @usuario VARCHAR(30) ,
      @funcion VARCHAR(5)
    )
RETURNS VARCHAR(500)
AS 
    BEGIN
        DECLARE @cOpciones VARCHAR(500)
        DECLARE @cOpcion VARCHAR(5)
        SET @cOpciones = ''
        DECLARE OpcionesCursor CURSOR FOR
        SELECT c.opcion+ ','  FROM perfiles AS a
        LEFT JOIN perfil_usuarios AS b ON a.idperfil=b.idperfil
        LEFT JOIN perfil_funcion AS c ON b.idperfil=c.idperfil
        WHERE a.sistema=@sistema AND b.usuario=@usuario AND c.funcion=@funcion
        OPEN OpcionesCursor
        FETCH NEXT FROM OpcionesCursor
  INTO @cOpcion
        WHILE @@fetch_status = 0 
            BEGIN
                SET @cOpciones = @cOpciones + @cOpcion
                FETCH NEXT FROM OpcionesCursor
		INTO @cOpcion
            END
        CLOSE OpcionesCursor
        DEALLOCATE OpcionesCursor
        RETURN @cOpciones 
    END
GO

IF not EXISTS(select syscolumns.name  from syscolumns
left join sysobjects on syscolumns.id= sysobjects.id
where syscolumns.name = 'empresa' and sysobjects.name='perfil_centro')
Alter table perfil_centro add empresa bigint null

Go

if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[perfil_reporte]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)  
CREATE TABLE [dbo].[perfil_reporte](
	[reporte] [varchar](100) NULL,
	[idPerfil] [bigint] NULL,
	[empresa] [bigint] NULL
) ON [PRIMARY]

GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosValidaEmpresaCentro'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosValidaEmpresaCentro
GO

CREATE PROCEDURE dbo.usuariosValidaEmpresaCentro

AS 
    
    SET NOCOUNT ON
    SET DATEFORMAT MDY   
    
    declare @vcentro as varchar(50)
    declare @vIdPerfil as bigint
    declare @vIdEmpresa as bigint
	
	DECLARE Centro_cursor CURSOR FOR 
	select centro, idperfil
	from perfil_centro
	where empresa is null
	
	OPEN Centro_cursor
	FETCH NEXT FROM Centro_cursor INTO @vcentro,@vidperfil
	WHILE @@FETCH_STATUS = 0
	BEGIN
	
		set @vIdEmpresa = 0
		
		select @vIdEmpresa=empresa
		from centros	
		where centro=@vcentro
		
		if @vIdEmpresa<>0
			begin
				update perfil_centro
				set empresa=@vIdEmpresa
				where centro=@vcentro
				and idperfil=@vIdPerfil
			end
		

		FETCH NEXT FROM Centro_cursor INTO @vcentro,@vidperfil
	END    
	DEALLOCATE Centro_cursor
go

exec usuariosValidaEmpresaCentro

go

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'userPasswordLength'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.userPasswordLength
GO

CREATE PROCEDURE dbo.userPasswordLength

AS
SET NOCOUNT ON
SET DATEFORMAT MDY

Select longitud_password from ctrl_usuarios

go

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'userDelete'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.userDelete
GO
create PROCEDURE dbo.userDelete
@usuario VARCHAR(20)
AS
SET NOCOUNT ON
SET DATEFORMAT MDY

delete from hpwd where usuario=@usuario
delete from perfil_usuarios where usuario=@usuario
Delete from usuarios where usuario=@usuario
go


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosPerfilesAsignadosAUsuarios'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosPerfilesAsignadosAUsuarios
GO
create PROCEDURE dbo.usuariosPerfilesAsignadosAUsuarios
( @idUsuario varchar(30))
AS
BEGIN 
	Select  sistema.nombre, 
			perfil_usuarios.idPerfil, 
			perfiles.Descripcion  
	from perfil_usuarios 
		left join  perfiles on perfil_usuarios.idperfil=perfiles.idperfil
		left join Sistema on perfiles.sistema=sistema.sistema			
	where usuario=@idusuario 
END
            
go 


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosRotacionPassword'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosRotacionPassword
GO
create PROCEDURE dbo.usuariosRotacionPassword
(@usuario VARCHAR(20),
 @password varchar(30))
AS
BEGIN 

	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY
    
    declare @result  int = 0
    declare @rotacion  decimal(9,0)
    declare @veces  int = 0
    declare @top varchar(500)
    
    create table #ResutadoTemporal
		(vpassword varchar(20),
		 numero int)
	
	select @rotacion = isnull(Rotacion_password,0)
	from Ctrl_usuarios 
	
	set @top = ' select Top ' + CONVERT(varchar(15),@rotacion) + ' password, count(*)' +
			   ' from hpwd ' + 
			   ' where usuario=''' + @usuario + '''' +
			   ' and password=''' + @password + '''' +
			   ' group by password'
	
	insert into #ResutadoTemporal exec (@top)
	
	select numero as numero from #ResutadoTemporal
		
END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 
end
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosListaPerfiles'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosListaPerfiles
GO
create PROCEDURE dbo.usuariosListaPerfiles

AS
BEGIN 
	Select  sistema.nombre, 
			perfil_usuarios.idPerfil, 
			perfiles.Descripcion  
	from perfil_usuarios 
		left join  perfiles on perfil_usuarios.idperfil=perfiles.idperfil
		left join Sistema on perfiles.sistema=sistema.sistema			
	
END
            
go                


IF not EXISTS(select syscolumns.name  from syscolumns 
left join sysobjects on syscolumns.id=sysobjects.id
where syscolumns.name = 'especiales' and sysobjects.name='Ctrl_usuarios')
Alter table Ctrl_usuarios add especiales numeric(2,0) null    
              
go

IF not EXISTS(select syscolumns.name  from syscolumns 
left join sysobjects on syscolumns.id=sysobjects.id
where syscolumns.name = 'mayusculas' and sysobjects.name='Ctrl_usuarios')
Alter table Ctrl_usuarios add mayusculas numeric(2,0) null    
              
go

IF not EXISTS(select syscolumns.name  from syscolumns 
left join sysobjects on syscolumns.id=sysobjects.id
where syscolumns.name = 'minusculas' and sysobjects.name='Ctrl_usuarios')
Alter table Ctrl_usuarios add minusculas numeric(2,0) null    
              
go


UPDATE Ctrl_usuarios set especiales=0 where especiales is null
UPDATE Ctrl_usuarios set mayusculas=0 where mayusculas is null
UPDATE Ctrl_usuarios set minusculas=0 where minusculas is null
go

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosCargaReglasCambioUsuario'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosCargaReglasCambioUsuario
GO
create PROCEDURE dbo.usuariosCargaReglasCambioUsuario
AS
BEGIN 
	SELECT Dias_vigencia
		  ,Longitud_password
		  ,Rotacion_password
		  ,Requiere_numeros
		  ,Dias_aviso
		  ,especiales
		  ,mayusculas
		  ,minusculas
    from ctrl_usuarios
END
            
GO

IF not EXISTS(select syscolumns.name from syscolumns 
					left join sysobjects on syscolumns.id=sysobjects.id
					where syscolumns.name = 'descripcion' and sysobjects.name='perfiles') 
	alter table perfiles alter column descripcion varchar(250)
GO
	
	if not exists( select sistema from Sistema where sistema='PP' )
		insert into Sistema values ('PP','Admin. Portal del Patron')
GO
	
	IF NOT EXISTS (SELECT * FROM funciones WHERE Sistema='PP' AND FUNCION='A' AND descripcion='Informe Ejecutivo Nomina' )
		INSERT INTO funciones(sistema,funcion,descripcion) VALUES  ('PP','A','Informe Ejecutivo Nomina')

	IF NOT EXISTS (SELECT * FROM funciones WHERE Sistema='PP' AND FUNCION='B' AND descripcion='Informe Ejecutivo Otros' )		
		INSERT INTO funciones(sistema,funcion,descripcion) VALUES  ('PP','B','Informe Ejecutivo Otros')
	
	IF NOT EXISTS (SELECT * FROM funciones WHERE Sistema='PP' AND FUNCION='C' AND descripcion='Pasivo Laboral' )
		INSERT INTO funciones(sistema,funcion,descripcion) VALUES  ('PP','C','Pasivo Laboral')
	
	IF NOT EXISTS (SELECT * FROM funciones WHERE Sistema='PP' AND FUNCION='D' AND descripcion='Reportes Varios' )
		INSERT INTO funciones(sistema,funcion,descripcion) VALUES  ('PP','D','Reportes Varios')
	
	IF NOT EXISTS (SELECT * FROM funciones WHERE Sistema='PP' AND FUNCION='E' AND descripcion='Indices y Estadisticas' )
		INSERT INTO funciones(sistema,funcion,descripcion) VALUES  ('PP','E','Indices y Estadisticas')
	
	IF NOT EXISTS (SELECT * FROM funciones WHERE Sistema='PP' AND FUNCION='F' AND descripcion='Horas Laboradas' )
		INSERT INTO funciones(sistema,funcion,descripcion) VALUES  ('PP','F','Horas Laboradas')
	
	IF NOT EXISTS (SELECT * FROM funciones WHERE Sistema='PP' AND FUNCION='G' AND descripcion='Utilerias Portales' )
		INSERT INTO funciones(sistema,funcion,descripcion) VALUES  ('PP','G','Utilerias Portales')
	
	IF NOT EXISTS (SELECT * FROM funciones WHERE Sistema='PP' AND FUNCION='H' AND descripcion='Historico Movimientos' )
		INSERT INTO funciones(sistema,funcion,descripcion) VALUES  ('PP','H','Historico Movimientos')
	
	IF NOT EXISTS (SELECT * FROM funciones WHERE Sistema='PP' AND FUNCION='I' AND descripcion='Historico de Incidencias' )
		INSERT INTO funciones(sistema,funcion,descripcion) VALUES  ('PP','I','Historico de Incidencias')
	
	IF NOT EXISTS (SELECT * FROM funciones WHERE Sistema='PP' AND FUNCION='J' AND descripcion='Auditoria de Sueldos' )
		INSERT INTO funciones(sistema,funcion,descripcion) VALUES  ('PP','J','Auditoria de Sueldos')
	
	IF NOT EXISTS (SELECT * FROM funciones WHERE Sistema='PP' AND FUNCION='K' AND descripcion='Recibos de Nomina' )
		INSERT INTO funciones(sistema,funcion,descripcion) VALUES  ('PP','K','Recibos de Nomina')
	
	IF NOT EXISTS (SELECT * FROM funciones WHERE Sistema='PP' AND FUNCION='L' AND descripcion='Kardex' )
		INSERT INTO funciones(sistema,funcion,descripcion) VALUES  ('PP','L','Kardex')
		
	IF NOT EXISTS (SELECT * FROM funciones WHERE Sistema='PP' AND FUNCION='M' AND descripcion='Excedentes IMSS' )	
		INSERT INTO funciones(sistema,funcion,descripcion) VALUES  ('PP','M','Excedentes IMSS')
GO		
	
	IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='PP' AND FUNCION='A' and opcion='A1' AND descripcion='Informe Ejecutivo Nomina' )	
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('A1','PP','A','Informe Ejecutivo Nomina')
	
	IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='PP' AND FUNCION='B' and opcion='B1' AND descripcion='Informe Ejecutivo Otros' )	
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('B1','PP','B','Informe Ejecutivo Otros')
	
	IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='PP' AND FUNCION='C' and opcion='C1' AND descripcion='pasivo Laboral' )	
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('C1','PP','C','Pasivo Laboral')
	
	IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='PP' AND FUNCION='D' and opcion='D1' AND descripcion='Reportes Varios' )	
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('D1','PP','D','Reportes Varios')
	
	IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='PP' AND FUNCION='E' and opcion='E1' AND descripcion='Indices y Estadisticas' )	
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('E1','PP','E','Indices y Estadisticas')
	
	IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='PP' AND FUNCION='F' and opcion='F1' AND descripcion='Horas Laboradas' )	
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('F1','PP','F','Horas Laboradas')
	
	IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='PP' AND FUNCION='G' and opcion='G1' AND descripcion='Utilerias Portales' )	
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('G1','PP','G','Utilerias Portales')
	
	IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='PP' AND FUNCION='H' and opcion='H1' AND descripcion='Historico Movimientos' )	
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('H1','PP','H','Historico Movimientos')
	
	IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='PP' AND FUNCION='I' and opcion='I1' AND descripcion='Historico de Incidencias' )	
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('I1','PP','I','Historico de Incidencias')
		
	IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='PP' AND FUNCION='J' and opcion='J1' AND descripcion='Auditoria de Sueldos' )	
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('J1','PP','J','Auditoria de Sueldos')
	
	IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='PP' AND FUNCION='K' and opcion='K1' AND descripcion='Recibos de Nomina' )	
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('K1','PP','K','Recibos de Nomina')
	
	IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='PP' AND FUNCION='L' and opcion='L1' AND descripcion='Kardex' )	
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('L1','PP','L','Kardex')
	
	IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='PP' AND FUNCION='M' and opcion='M1' AND descripcion='Excedentes IMSS' )	
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('M1','PP','M','Excedentes IMSS')
		
GO		

	IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='CA' AND FUNCION='M' and opcion='M2' AND descripcion='Catalogos' )	
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('M2','CA','M','Catalogos')

	IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='CA' AND FUNCION='M' and opcion='M3' AND descripcion='Operacion' )	
		inSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('M3','CA','M','Operacion')

	IF NOT EXISTS (SELECT * FROM opciones WHERE Sistema='CA' AND FUNCION='M' and opcion='M4' AND descripcion='Reportes' )	
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('M4','CA','M','Reportes')

go

IF NOT EXISTS (SELECT * 
				FROM perfiles
				left join perfil_funcion on perfiles.idperfil=perfil_funcion.idperfil
				WHERE descripcion='Administrador de Capacitacion' 
				and funcion='M' and opcion='M2'
				  )	

insert into perfil_funcion(funcion, opcion, idPerfil) 
 select 'M','M2', idperfil from perfiles where descripcion='Administrador de Capacitacion'

 go

 IF NOT EXISTS (SELECT * 
				FROM perfiles
				left join perfil_funcion on perfiles.idperfil=perfil_funcion.idperfil
				WHERE descripcion='Administrador de Capacitacion' 
				and funcion='M' and opcion='M3'
				  )	
 insert into perfil_funcion(funcion, opcion, idPerfil) 
 select 'M','M3', idperfil from perfiles where descripcion='Administrador de Capacitacion'
 go


 IF NOT EXISTS (SELECT * 
				FROM perfiles
				left join perfil_funcion on perfiles.idperfil=perfil_funcion.idperfil
				WHERE descripcion='Administrador de Capacitacion' 
				and funcion='M' and opcion='M4'
				  )	

 insert into perfil_funcion(funcion, opcion, idPerfil) 
 select 'M','M4', idperfil from perfiles where descripcion='Administrador de Capacitacion'

go

IF NOT EXISTS (SELECT * FROM perfiles WHERE descripcion='Administrador Portal del Patron' )	
insert into perfiles values ('Administrador Portal del Patron','PP','{}','{}','N','N',null) 
go

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'insertaPermisosAdministradorPortalPatron'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.insertaPermisosAdministradorPortalPatron
GO
create PROCEDURE dbo.insertaPermisosAdministradorPortalPatron

AS
BEGIN 

	declare @idperfil as bigint
	declare @cantidad as bigint
	
	SELECT @idperfil=idperfil FROM perfiles WHERE upper(descripcion)='ADMINISTRADOR PORTAL DEL PATRON' or UPPER(descripcion)='ADMIN. PORTAL DEL PATRON'
	
	if @idperfil>0	
		IF NOT EXISTS (	select idperfil from perfil_usuarios where idperfil=@idperfil and usuario='administrador' )
		insert into perfil_usuarios values (@idperfil,'administrador')	

END
            
go 

exec insertaPermisosAdministradorPortalPatron
go


IF EXISTS (SELECT * FROM opciones WHERE Sistema='TP' AND FUNCION='A' and opcion='A1')	
	update opciones set descripcion= 'Consultar' where opcion='A1' and sistema='TP' and funcion='A'
go

IF EXISTS (SELECT * FROM opciones WHERE Sistema='TP' AND FUNCION='A' and opcion='A2')	
	update opciones set descripcion= 'Solicitar Vacaciones' where opcion='A2' and sistema='TP' and funcion='A'
go

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'insertaPermisosReportesAPerfilesExistentes'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.insertaPermisosReportesAPerfilesExistentes
GO
create PROCEDURE dbo.insertaPermisosReportesAPerfilesExistentes

AS
BEGIN 

	declare @existePermiso int
	
	select @existePermiso=count(idperfil)
	from perfil_funcion
	where idperfil in (select idperfil from perfiles where sistema='TP')
	and funcion='R' and opcion='R2'
	
	if @existePermiso=0
		begin
			insert into perfil_funcion 
			select 'R','R2', idperfil from perfiles where sistema='TP'
			
			insert into perfil_funcion 
			select 'R','R3', idperfil from perfiles where sistema='TP'
			
			insert into perfil_funcion 
			select 'R','R4', idperfil from perfiles where sistema='TP'
			
			insert into perfil_funcion 
			select 'R','R5', idperfil from perfiles where sistema='TP'
			
			insert into perfil_funcion 
			select 'R','R6', idperfil from perfiles where sistema='TP'
			
			insert into perfil_funcion 
			select 'R','R7', idperfil from perfiles where sistema='TP'
			
			insert into perfil_funcion 
			select 'R','R8', idperfil from perfiles where sistema='TP'
			
			insert into perfil_funcion 
			select 'R','R9', idperfil from perfiles where sistema='TP'
			
			insert into perfil_funcion 
			select 'R','R10', idperfil from perfiles where sistema='TP'
			
			insert into perfil_funcion 
			select 'A','A3', idperfil from perfiles where sistema='TP'
		end

END
            
go 

exec insertaPermisosReportesAPerfilesExistentes
go


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'obtenListadoDeBasesDeDatos'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.obtenListadoDeBasesDeDatos
GO
create PROCEDURE dbo.obtenListadoDeBasesDeDatos

AS
BEGIN 

	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY
		
		declare @basesDeDatos as table(name varchar(500),id bigint)

		insert into @basesDeDatos
		SELECT	name, 
				DENSE_RANK() OVER (PARTITION BY 1 ORDER BY name ASC) as id
				--database_id, create_date
		FROM sys.databases

		declare @max bigint = (select max(id) from @basesDeDatos)
		declare @conta bigint = 1
		declare @Base varchar(500)
		declare @sql varchar(max)
		declare @respuesta int
		declare @bases as table(valida bigint,name varchar(500))

		while @conta<=@max
		begin
			set @Base = (select name from @basesDeDatos where id=@conta)
			set @sql = 'select isnull((SELECT 1 FROM '+@base+'.INFORMATION_SCHEMA.TABLES where table_name = ''avisos_imss''),0),'''+@base+''''--'IF EXISTS ( SELECT  name FROM    dbo.sysobjects WHERE   id = OBJECT_ID(N''['+@base+'].[dbo].[avisos_imss]'') AND OBJECTPROPERTY(id, N''IsUserTable'') = 1 ) begin select 1,'''+@base+''' end else begin select 0,'''+@base+''' end' 
	
			insert into @bases
			exec(@sql)
	
			set @conta+=1
		end

		select * 
		from @bases
		where valida=1
		
END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 
end
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosValidaUsuario'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosValidaUsuario
GO
create PROCEDURE dbo.usuariosValidaUsuario
	(
	@usuario as varchar(50),
	@password as varchar(50)
	)
AS
BEGIN 

	declare @existe as int
	declare @Valido as int
	declare @expiracion as datetime
	declare @descripcion as varchar(250)
	declare @diasAviso as int

	Select @existe=count(usuario)
	from usuarios 
    where  convert(varbinary(50),usuario)= convert(varbinary(50),@usuario)
    and password=@password
    
    Select @diasAviso=dias_aviso
	from Ctrl_usuarios 
    
    if @existe=1
    begin
		Select @expiracion=datediff("dd",getdate(), expiracion)
		from usuarios 
		where usuario=@usuario
		and password=@password
		
		if @expiracion<0
			set @existe=2
			
		if @expiracion>=0 and @expiracion<=@diasAviso
			set @existe=3	
    end

     select @existe --0 No existe, 1 Existe, 2 expirado, 3 Por expirar

END
            
go    

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosCargaPerfil'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosCargaPerfil
GO
create PROCEDURE dbo.usuariosCargaPerfil
(@usuario VARCHAR(20),
 @sistema char(2))
AS

BEGIN 

	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY
    
	SELECT  perfiles.idperfil, 
			perfiles.empresas, 
			perfiles.nomina, 
			perfiles.actualizar, 
			perfiles.sueldo
	FROM perfil_usuarios 
		left join perfiles on perfiles.idperfil=perfil_usuarios.idperfil
	WHERE perfil_usuarios.usuario=@usuario
		and perfiles.sistema=@sistema

	END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 

END
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosCargaFuncionesOpcionesPorPerfil'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosCargaFuncionesOpcionesPorPerfil
GO
create PROCEDURE dbo.usuariosCargaFuncionesOpcionesPorPerfil
(@idperfil bigint)
AS

BEGIN 

	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY
    
	select perfil_funcion.funcion, perfil_funcion.opcion 
	from perfiles
	left join perfil_funcion on perfiles.idperfil=perfil_funcion.idperfil
	where perfiles.idperfil=@idperfil
	order by perfil_funcion.funcion

	END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 

END
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosCargaEmpresas'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosCargaEmpresas
GO
create PROCEDURE dbo.usuariosCargaEmpresas
(@usuario VARCHAR(20),
@idPerfil bigint)
AS

BEGIN 

	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY
    
		declare @stringEmpresas varchar(500)
		declare @select varchar (1000)
		declare @from varchar(500)
		declare @where varchar(max)
		
		set @select= ' select empresa, nombre_empresa, isnull(referencia,'''')'
		set @from= ' from empresas'
		set @where= ' '
	    
		Select @stringEmpresas = perfiles.empresas 
		from usuarios
			left join perfil_usuarios on usuarios.usuario=perfil_usuarios.usuario
			left join perfiles on  perfil_usuarios.idperfil=perfiles.idperfil
		where usuarios.usuario= @usuario  
		and perfiles.idperfil=@idPerfil
	    
		set @stringEmpresas=SUBSTRING(@stringempresas,2,len(@stringEmpresas)-2)
		
		if len(@stringEmpresas)>0
			set @where = ' where empresa in (' + @stringEmpresas + ')'
		
		exec (@select + @from + @where)

	END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 

END
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosCambiarPassword'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosCambiarPassword
GO
create PROCEDURE dbo.usuariosCambiarPassword
(@usuario VARCHAR(20),
 @password varchar(30))
AS
BEGIN 

	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY
		
	update usuarios set password=@password, 
	expiracion = expiracion + (select isnull(Dias_vigencia,0) from Ctrl_usuarios)
	where usuario=@usuario
	
	insert into hpwd(usuario, fch_modifico, password) 
	values (@usuario,getdate(),@password)
		
END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 
end
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'obtenListadoDeBasesDeDatos'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.obtenListadoDeBasesDeDatos
GO
create PROCEDURE dbo.obtenListadoDeBasesDeDatos

AS
BEGIN 

	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY
		
		declare @basesDeDatos as table(name varchar(500),id bigint)

		insert into @basesDeDatos
		SELECT	name, 
				DENSE_RANK() OVER (PARTITION BY 1 ORDER BY name ASC) as id
				--database_id, create_date
		FROM sys.databases

		declare @max bigint = (select max(id) from @basesDeDatos)
		declare @conta bigint = 1
		declare @Base varchar(500)
		declare @sql varchar(max)
		declare @respuesta int
		declare @bases as table(valida bigint,name varchar(500))

		while @conta<=@max
		begin
			set @Base = (select name from @basesDeDatos where id=@conta)
			set @sql = 'select isnull((SELECT 1 FROM '+@base+'.INFORMATION_SCHEMA.TABLES where table_name = ''avisos_imss''),0),'''+@base+''''--'IF EXISTS ( SELECT  name FROM    dbo.sysobjects WHERE   id = OBJECT_ID(N''['+@base+'].[dbo].[avisos_imss]'') AND OBJECTPROPERTY(id, N''IsUserTable'') = 1 ) begin select 1,'''+@base+''' end else begin select 0,'''+@base+''' end' 
	
			insert into @bases
			exec(@sql)
	
			set @conta+=1
		end

		select * 
		from @bases
		where valida=1
		
END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 
end
GO

 IF OBJECT_ID(N'PK4_6') IS NOT NULL
ALTER TABLE [dbo].[perfil_centro] DROP CONSTRAINT [PK4_6] 
GO


if exists (SELECT distinct(c.name)  
                  FROM dbo.SYSCOLUMNS C  
                  INNER JOIN dbo.SYSOBJECTS T   
                  ON C.[ID] = T.[ID]   
                  WHERE T.XTYPE = 'U'   
                  and t.name='perfiles'   
                  and c.name='empresas')  
  ALTER TABLE perfiles alter column empresas varchar(650) NULL 
go  


if exists (SELECT distinct(c.name)  
                  FROM dbo.SYSCOLUMNS C  
                  INNER JOIN dbo.SYSOBJECTS T   
                  ON C.[ID] = T.[ID]   
                  WHERE T.XTYPE = 'U'   
                  and t.name='perfiles'   
                  and c.name='nomina')  
  ALTER TABLE perfiles alter column nomina varchar(150) NULL 
go  


IF not EXISTS(select syscolumns.name  from syscolumns 
left join sysobjects on syscolumns.id=sysobjects.id
where syscolumns.name = 'email' and sysobjects.name='usuarios')
Alter table usuarios add email varchar(250) null    
              
go

IF OBJECT_ID(N'dbo.AccesoaFunciones') IS NOT NULL 
    DROP FUNCTION dbo.AccesoaFunciones
GO

CREATE FUNCTION dbo.AccesoaFunciones ( @idperfil INT )
RETURNS VARCHAR(500)
AS 
    BEGIN
        DECLARE @cfunciones VARCHAR(500)
        DECLARE @cfuncion VARCHAR(5)
        SET @cfunciones = ''
        DECLARE funcionesCursor CURSOR FOR
        SELECT DISTINCT(RTRIM(z.funcion)+',') FROM perfil_funcion AS Z WHERE @idperfil=Z.idperfil
        OPEN funcionesCursor
        FETCH NEXT FROM funcionesCursor
  INTO @cfuncion
        WHILE @@fetch_status = 0 
            BEGIN
                SET @cfunciones = @cfunciones + @cfuncion
                FETCH NEXT FROM funcionesCursor
		INTO @cfuncion
            END
        CLOSE funcionesCursor
        DEALLOCATE funcionesCursor	
        RETURN @cfunciones 
    END
GO

IF OBJECT_ID(N'dbo.AccesoaOpciones') IS NOT NULL 
    DROP FUNCTION dbo.AccesoaOpciones
GO

CREATE FUNCTION dbo.AccesoaOpciones
    (
      @sistema VARCHAR(5) ,
      @usuario VARCHAR(30) ,
      @funcion VARCHAR(5)
    )
RETURNS VARCHAR(500)
AS 
    BEGIN
        DECLARE @cOpciones VARCHAR(500)
        DECLARE @cOpcion VARCHAR(5)
        SET @cOpciones = ''
        DECLARE OpcionesCursor CURSOR FOR
        SELECT c.opcion+ ','  FROM perfiles AS a
        LEFT JOIN perfil_usuarios AS b ON a.idperfil=b.idperfil
        LEFT JOIN perfil_funcion AS c ON b.idperfil=c.idperfil
        WHERE a.sistema=@sistema AND b.usuario=@usuario AND c.funcion=@funcion
        OPEN OpcionesCursor
        FETCH NEXT FROM OpcionesCursor
  INTO @cOpcion
        WHILE @@fetch_status = 0 
            BEGIN
                SET @cOpciones = @cOpciones + @cOpcion
                FETCH NEXT FROM OpcionesCursor
		INTO @cOpcion
            END
        CLOSE OpcionesCursor
        DEALLOCATE OpcionesCursor
        RETURN @cOpciones 
    END
GO

IF not EXISTS(select syscolumns.name  from syscolumns
left join sysobjects on syscolumns.id= sysobjects.id
where syscolumns.name = 'empresa' and sysobjects.name='perfil_centro')
Alter table perfil_centro add empresa bigint null

Go

if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[perfil_reporte]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)  
CREATE TABLE [dbo].[perfil_reporte](
	[reporte] [varchar](100) NULL,
	[idPerfil] [bigint] NULL,
	[empresa] [bigint] NULL
) ON [PRIMARY]

GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosValidaEmpresaCentro'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosValidaEmpresaCentro
GO

CREATE PROCEDURE dbo.usuariosValidaEmpresaCentro

AS 
    
    SET NOCOUNT ON
    SET DATEFORMAT MDY   
    
    declare @vcentro as varchar(50)
    declare @vIdPerfil as bigint
    declare @vIdEmpresa as bigint
	
	DECLARE Centro_cursor CURSOR FOR 
	select centro, idperfil
	from perfil_centro
	where empresa is null
	
	OPEN Centro_cursor
	FETCH NEXT FROM Centro_cursor INTO @vcentro,@vidperfil
	WHILE @@FETCH_STATUS = 0
	BEGIN
	
		set @vIdEmpresa = 0
		
		select @vIdEmpresa=empresa
		from centros	
		where centro=@vcentro
		
		if @vIdEmpresa<>0
			begin
				update perfil_centro
				set empresa=@vIdEmpresa
				where centro=@vcentro
				and idperfil=@vIdPerfil
			end
		

		FETCH NEXT FROM Centro_cursor INTO @vcentro,@vidperfil
	END    
	DEALLOCATE Centro_cursor
go

exec usuariosValidaEmpresaCentro

go


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'userPasswordLength'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.userPasswordLength
GO

CREATE PROCEDURE dbo.userPasswordLength

AS
SET NOCOUNT ON
SET DATEFORMAT MDY

Select longitud_password from ctrl_usuarios

go

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'userDelete'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.userDelete
GO
create PROCEDURE dbo.userDelete
@usuario VARCHAR(20)
AS
SET NOCOUNT ON
SET DATEFORMAT MDY

delete from hpwd where usuario=@usuario
delete from perfil_usuarios where usuario=@usuario
Delete from usuarios where usuario=@usuario
go


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosPerfilesAsignadosAUsuarios'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosPerfilesAsignadosAUsuarios
GO
create PROCEDURE dbo.usuariosPerfilesAsignadosAUsuarios
( @idUsuario varchar(30))
AS
BEGIN 
	Select  sistema.nombre, 
			perfil_usuarios.idPerfil, 
			perfiles.Descripcion  
	from perfil_usuarios 
		left join  perfiles on perfil_usuarios.idperfil=perfiles.idperfil
		left join Sistema on perfiles.sistema=sistema.sistema			
	where usuario=@idusuario 
END
            
go            


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosListaPerfiles'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosListaPerfiles
GO
create PROCEDURE dbo.usuariosListaPerfiles

AS
BEGIN 
	Select  sistema.nombre, 
			perfil_usuarios.idPerfil, 
			perfiles.Descripcion  
	from perfil_usuarios 
		left join  perfiles on perfil_usuarios.idperfil=perfiles.idperfil
		left join Sistema on perfiles.sistema=sistema.sistema			
	
END
            
go   

if not exists (SELECT distinct(c.name)  
                  FROM dbo.SYSCOLUMNS C  
                  INNER JOIN dbo.SYSOBJECTS T   
                  ON C.[ID] = T.[ID]   
                  WHERE T.XTYPE = 'U'   
                  and t.name='usuarios'   
                  and c.name='fechaCambio')  
  ALTER TABLE usuarios add  fechaCambio datetime NULL 
go 

if not exists (SELECT distinct(c.name)  
                  FROM dbo.SYSCOLUMNS C  
                  INNER JOIN dbo.SYSOBJECTS T   
                  ON C.[ID] = T.[ID]   
                  WHERE T.XTYPE = 'U'   
                  and t.name='usuarios'   
                  and c.name='motivoCambio')  
  ALTER TABLE usuarios add motivoCambio varchar(250) NULL 
go 





IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'userInsert'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.userInsert
GO

CREATE PROCEDURE [dbo].[userInsert]
	@usuario VARCHAR(20),
	@descripcion varchar(30),
	@password varchar(30),
	@expiracion integer,
	@email varchar(50),
	@fechaCambio datetime,
	@motivoCambio varchar(250)
AS
BEGIN
	SET NOCOUNT ON
	SET DATEFORMAT MDY

	INSERT INTO usuarios
				(usuario
				,descripcion
				,password
				,expiracion
				,email
				,fechaalta
				,fechacambio
				,motivoCambio)
	VALUES
		(@usuario
		,@descripcion
		,@password
		,getdate() + @expiracion
		,@email
		,GETDATE()
		,@fechaCambio
		,@motivoCambio)
END
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'userUpdate'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.userUpdate
GO
CREATE PROCEDURE [dbo].[userUpdate]
	@usuario VARCHAR(20),
	@descripcion varchar(30),
	@password varchar(30),
	@expiracion integer,
	@email varchar(50),
	@fechaCambio datetime,
	@motivoCambio varchar(250)
AS
	SET NOCOUNT ON
	SET DATEFORMAT MDY

	UPDATE [dbo].[usuarios]
	SET [descripcion] = @descripcion
	,[password] =@password
	,[expiracion] = getdate() + @expiracion
	,[email] = @email
	,fechacambio= @fechaCambio
	,motivocambio=@motivocambio
	WHERE [usuario] = @usuario

GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'userUpdate'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.userUpdate
GO
CREATE PROCEDURE [dbo].[userUpdate]
	@usuario VARCHAR(20),
	@descripcion varchar(30),
	@password varchar(30),
	@expiracion integer,
	@email varchar(50),
	@fechaCambio datetime,
	@motivoCambio varchar(250)
AS
	SET NOCOUNT ON
	SET DATEFORMAT MDY

	UPDATE [dbo].[usuarios]
	SET [descripcion] = @descripcion
	,[password] =@password
	,[expiracion] = getdate() + @expiracion
	,[email] = @email
	,fechacambio= @fechaCambio
	,motivocambio=@motivocambio
	WHERE [usuario] = @usuario

GO



IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosDesactivar'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosDesactivar
GO
create PROCEDURE dbo.usuariosDesactivar
( @idusuario varchar(30))
AS
BEGIN 
	update usuarios 
	set expiracion = '19000101',
	    fechacambio = getdate(),
	    motivoCAmbio = 'Desactivado'
	where usuario = @idusuario

	select isnull(max(empresa),1) 
           ,getdate()
           ,'00:00:00'
           ,'B'
           ,0
           ,'B2'
           ,'Desactivar'
           ,''
           ,@idusuario 
           ,''
           ,''
           ,'US'
		   from empresas
	
END
            
go 


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosActivar'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosActivar
GO
create PROCEDURE dbo.usuariosActivar
(@idusuario varchar(30))
AS
BEGIN 
	declare @dias bigint
    select @dias=isnull(Dias_vigencia,0) 
	from Ctrl_usuarios

	update usuarios 
	set expiracion = getdate() + @dias,
	    fechacambio = getdate(),
	    motivoCAmbio = 'Activado'
	where usuario = @idusuario

	select isnull(max(empresa),1) 
           ,getdate()
           ,'00:00:00'
           ,'B'
           ,0
           ,'B2'
           ,'Activar'
           ,''
           ,@idusuario 
           ,''
           ,''
           ,'US'
		   from empresas
	
END            
GO


if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[UsuariosTemporalRegistro]') and OBJECTPROPERTY(id, N'IsUserTable') = 1) 
CREATE TABLE [dbo].[UsuariosTemporalRegistro](
	[usuario] [varchar](30) NULL,
	[horaRegistro] [datetime] NULL,
	[sistema] [char](2) NULL
) ON [PRIMARY]
GO

if not exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[UsuariosTemporalRegistroEmpleado]') and OBJECTPROPERTY(id, N'IsUserTable') = 1) 
CREATE TABLE [dbo].[UsuariosTemporalRegistroEmpleado](
	[empleado] bigint NULL,
	[empresa] bigint NULL,
	[horaRegistro] [datetime] NULL,
	[sistema] [char](2) NULL
) ON [PRIMARY]
GO

if not exists (SELECT distinct(c.name)  
                  FROM dbo.SYSCOLUMNS C  
                  INNER JOIN dbo.SYSOBJECTS T   
                  ON C.[ID] = T.[ID]   
                  WHERE T.XTYPE = 'U'   
                  and t.name='ctrl_usuarios'   
                  and c.name='intentos')  
  ALTER TABLE ctrl_usuarios add intentos int NULL 
go 

update ctrl_usuarios set intentos=0 where intentos is null
go

if not exists (SELECT distinct(c.name)  
                  FROM dbo.SYSCOLUMNS C  
                  INNER JOIN dbo.SYSOBJECTS T   
                  ON C.[ID] = T.[ID]   
                  WHERE T.XTYPE = 'U'   
                  and t.name='ctrl_usuarios'   
                  and c.name='tiempoDeBloqueo')  
  ALTER TABLE ctrl_usuarios add tiempoDeBloqueo int NULL 
GO 

update ctrl_usuarios set tiempoDeBloqueo=0 where tiempoDeBloqueo is null
GO


if not exists (SELECT distinct(c.name)  
                  FROM dbo.SYSCOLUMNS C  
                  INNER JOIN dbo.SYSOBJECTS T   
                  ON C.[ID] = T.[ID]   
                  WHERE T.XTYPE = 'U'   
                  and t.name='usuarios'   
                  and c.name='BloqueadoPorIntentos')  
  ALTER TABLE usuarios add BloqueadoPorIntentos int NULL 
go 

update usuarios set BloqueadoPorIntentos=0 where BloqueadoPorIntentos is null
GO

if not exists (SELECT distinct(c.name)  
                  FROM dbo.SYSCOLUMNS C  
                  INNER JOIN dbo.SYSOBJECTS T   
                  ON C.[ID] = T.[ID]   
                  WHERE T.XTYPE = 'U'   
                  and t.name='usuarios'   
                  and c.name='HoraDeBloqueo')  
  ALTER TABLE usuarios add HoraDeBloqueo datetime NULL 
go 

update usuarios set HoraDeBloqueo='19000101' where HoraDeBloqueo is null
GO

if not exists (SELECT distinct(c.name)  
                  FROM dbo.SYSCOLUMNS C  
                  INNER JOIN dbo.SYSOBJECTS T   
                  ON C.[ID] = T.[ID]   
                  WHERE T.XTYPE = 'U'   
                  and t.name='ctrl_usuarios'   
                  and c.name='bloqueaAdmin')  
  ALTER TABLE ctrl_usuarios add bloqueaAdmin int NULL 
go 

update ctrl_usuarios set bloqueaAdmin=0 where bloqueaAdmin is null
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosDesbloquear'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosDesbloquear
GO
create PROCEDURE dbo.usuariosDesbloquear
(@idusuario varchar(30))
AS
BEGIN 

	update usuarios 
	set BloqueadoPorIntentos = 0,
	    HoraDeBloqueo = '19000101'
	where usuario = @idusuario

	delete from UsuariosTemporalRegistro where usuario=@idusuario
	
END            
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosRevisaIntentos'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosRevisaIntentos
GO
create PROCEDURE dbo.usuariosRevisaIntentos
(@idusuario varchar(30), 
 @password varchar(30),
 @sistema char(2))
AS
     SET NOCOUNT ON
     SET DATEFORMAT MDY
     SET XACT_ABORT ON
     BEGIN TRANSACTION

	 BEGIN TRY

	declare @intentosPermitidos int
	declare @tiempoDeBloqueo datetime

	declare @EstaBloqueado int
	declare @horaDeBloqueo datetime
	declare @horaDeBloqueofinal datetime

	declare @Resultado int
	declare @usuarioValido int
	declare @intentosEnTemporal int
	declare @pasaAdministrador int
	declare @ultimoIntento datetime

	declare @minutosLlevaBloqueado bigint
	declare @MOTIVO VARCHAR(15)

	set @resultado=1
	set @usuarioValido = 0

	select @intentosPermitidos=intentos, @tiempoDeBloqueo=tiempoDeBloqueo
	from ctrl_usuarios

	if @intentosPermitidos>0
		Begin

			Select @EstaBloqueado=bloqueadoporintentos,@horaDeBloqueo=HoraDeBloqueo
			from usuarios
			where usuario=@idusuario

			select @minutosLlevaBloqueado=datediff(minute, @horaDeBloqueo,getdate())

			if @EstaBloqueado= 1
				begin
					if @minutosLlevaBloqueado<=@tiempoDeBloqueo
			 			--bloqueado sin tiempo transcurrido
						begin
							set @resultado=5
						end
					if @minutosLlevaBloqueado>@tiempoDeBloqueo
						--revisar la hora del ultimo intento y si ya pas lo reglamentario borrar registros, si no esperar mas.
						begin
							update usuarios set BloqueadoPorIntentos=0, HoraDeBloqueo='19000101' where usuario=@idusuario
							delete from UsuariosTemporalRegistro 
							where usuario=@idusuario

							delete from UsuariosTemporalRegistro where usuario=@idusuario
						end
				end

			if @EstaBloqueado=0
				begin
					select @horaDeBloqueofinal = getdate()
						from usuarios

					insert into usuariosTemporalRegistro (usuario,horaRegistro,sistema)
						values (@idusuario, @horaDeBloqueofinal ,@sistema)

					select @intentosEnTemporal=count(*)
						from UsuariosTemporalRegistro 
						where usuario=@idusuario
						and sistema=@sistema

					update UsuariosTemporalRegistro
						set horaRegistro=@horaDeBloqueofinal
							where usuario=@idusuario
						and sistema=@sistema

					if @intentosEnTemporal>@intentosPermitidos
						begin
							--excede el limite permitido 
							
							set @resultado=9
							update usuarios 
								set bloqueadoPorIntentos=1 , 
								horaDeBloqueo=@horaDeBloqueofinal
								where usuario=@idusuario

						end

					if @intentosEnTemporal<=@intentosPermitidos
						-- puede pasar
						begin
							set @resultado=1
						end
				end
		End

	select @usuarioValido=count(*) 
	from usuarios 
	where usuario=@idusuario 
	and password=@password

	if @usuarioValido>0
		begin	
			Select @MOTIVO=motivocambio 
			from usuarios
			WHERE USUARIO=@idusuario

			IF @MOTIVO='Desactivado'
				SET @usuarioValido=2

		end

	select @pasaAdministrador=bloqueaAdmin
	from ctrl_usuarios

	if upper(@idusuario)='ADMINISTRADOR' and @pasaAdministrador=0
		begin
			set @resultado=1
			delete from UsuariosTemporalRegistro where usuario=@idusuario
		end

	select @usuarioValido, @resultado from Ctrl_usuarios


	  END TRY
     BEGIN CATCH

         IF ( XACT_STATE() ) = -1
             OR @@TRANCOUNT > 0
             ROLLBACK TRANSACTION

         SELECT  ERROR_NUMBER() AS ErrorNumber ,
                 ERROR_SEVERITY() AS ErrorSeverity ,
                 ERROR_STATE() AS ErrorState ,
                 ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                 ERROR_LINE() AS ErrorLine ,
                 ERROR_MESSAGE() AS ErrorMessage

     END CATCH

     IF @@TRANCOUNT > 0
         COMMIT TRANSACTION
         
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosEliminaTemporalUsuarios'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosEliminaTemporalUsuarios
GO
create PROCEDURE dbo.usuariosEliminaTemporalUsuarios
(@idusuario varchar(30),
 @sistema char(2))
AS
     SET NOCOUNT ON
     SET DATEFORMAT MDY
     SET XACT_ABORT ON
     BEGIN TRANSACTION

	 BEGIN TRY

		delete from UsuariosTemporalRegistro 
		where usuario=@idusuario

	 END TRY
     BEGIN CATCH

         IF ( XACT_STATE() ) = -1
             OR @@TRANCOUNT > 0
             ROLLBACK TRANSACTION

         SELECT  ERROR_NUMBER() AS ErrorNumber ,
                 ERROR_SEVERITY() AS ErrorSeverity ,
                 ERROR_STATE() AS ErrorState ,
                 ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                 ERROR_LINE() AS ErrorLine ,
                 ERROR_MESSAGE() AS ErrorMessage

     END CATCH

     IF @@TRANCOUNT > 0
         COMMIT TRANSACTION
         
GO



IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosEliminaTemporalEmpleados'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosEliminaTemporalEmpleados
GO
create PROCEDURE dbo.usuariosEliminaTemporalEmpleados
(@empleado varchar(30),
@empresa bigint)
AS
     SET NOCOUNT ON
     SET DATEFORMAT MDY
     SET XACT_ABORT ON
     BEGIN TRANSACTION

	 BEGIN TRY

		delete from UsuariosTemporalRegistroEmpleado 
		where empleado=@empleado
		and empresa=@empresa

	 END TRY
     BEGIN CATCH

         IF ( XACT_STATE() ) = -1
             OR @@TRANCOUNT > 0
             ROLLBACK TRANSACTION

         SELECT  ERROR_NUMBER() AS ErrorNumber ,
                 ERROR_SEVERITY() AS ErrorSeverity ,
                 ERROR_STATE() AS ErrorState ,
                 ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                 ERROR_LINE() AS ErrorLine ,
                 ERROR_MESSAGE() AS ErrorMessage

     END CATCH

     IF @@TRANCOUNT > 0
         COMMIT TRANSACTION
         
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosListaInicial'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosListaInicial
GO

CREATE PROCEDURE [dbo].usuariosListaInicial
    @usuario VARCHAR(20)
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
	
	if @usuario=''
		Select usuario, 
		descripcion, 
		convert(varchar(10),expiracion,103),
		email, 
		motivoCambio as estatus,
		case bloqueadoPorIntentos 
		when 0 then 'No'
		when 1 then 'Si'
		end as bloqueado
		from usuarios
	else
		Select usuario, 
		descripcion, 
		convert(varchar(10),expiracion,103),
		email, 
		motivoCambio as estatus,
		case bloqueadoPorIntentos 
		when 0 then 'No'
		when 1 then 'Si'
		end as bloqueado
		from usuarios
		where usuario=@usuario	
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'userRevisaBloqueos'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.userRevisaBloqueos
GO

CREATE PROCEDURE [dbo].userRevisaBloqueos
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  

	declare @tiempoBloqueo as int
	
	select @tiempoBloqueo = tiempoDeBloqueo
	from Ctrl_usuarios
		  
	delete from UsuariosTemporalRegistro
	where usuario in ( Select usuario 
						from usuarios
						where bloqueadoporintentos=1 
						and datediff(MINUTE,horadebloqueo,getdate())>@tiempoBloqueo)

	update usuarios
	set bloqueadoporintentos=0,
	horadebloqueo='19000101'
	where usuario in ( Select usuario 
						from usuarios
						where bloqueadoporintentos=1 
						and datediff(MINUTE,horadebloqueo,getdate())>@tiempoBloqueo)


	delete from UsuariosTemporalRegistro
	where usuario in ( Select usuario 
						from UsuariosTemporalRegistro
						where datediff(MINUTE,horaregistro,getdate())>1440)


Go
  
IF NOT EXISTS ( SELECT  *
                 FROM    dbo.sysobjects
                 WHERE   id = OBJECT_ID(N'[dbo].[perfil_empleado]')
                         AND OBJECTPROPERTY(id, N'IsUserTable') = 1 )
     BEGIN
     
		 CREATE TABLE [dbo].[perfil_empleado](
			[idPerfil] [bigint] NOT NULL,
			[empresa] [bigint] NOT NULL,
			[codigo] [numeric](8, 0) NOT NULL,
		 CONSTRAINT [PK_perfil_empleado] PRIMARY KEY CLUSTERED 
		(
			[idPerfil] ASC,
			[empresa] ASC,
			[codigo] ASC
		) ON [PRIMARY]
		) ON [PRIMARY]
		     
     end
go

IF not EXISTS(select syscolumns.name  from syscolumns 
left join sysobjects on syscolumns.id=sysobjects.id
where syscolumns.name = 'bloqueado' and sysobjects.name='perfil_empleado')
Alter table perfil_empleado add bloqueado int null                
go

IF not EXISTS(select syscolumns.name  from syscolumns 
left join sysobjects on syscolumns.id=sysobjects.id
where syscolumns.name = 'horaBloqueo' and sysobjects.name='perfil_empleado')
Alter table perfil_empleado add horaBloqueo datetime null              
go

update perfil_empleado set bloqueado=0 where bloqueado is null
go
update perfil_empleado set horaBloqueo='19000101' where horaBloqueo is null
go

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'InsertarEmpleadoTodos'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.InsertarEmpleadoTodos
GO

CREATE PROCEDURE [dbo].InsertarEmpleadoTodos
	(@idperfil as bigint)
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY 
    
    declare @codigo bigint
    DECLARE @empresa  bigint
    
    DECLARE empleadosCursor CURSOR FOR
			select codigo, empresa
			from empleados 
    OPEN empleadosCursor
        FETCH NEXT FROM empleadosCursor INTO @codigo,@empresa
        WHILE @@fetch_status = 0 
            BEGIN            
				IF NOT EXISTS(SELECT * FROM perfil_empleado WHERE idPerfil=@idperfil AND empresa=@empresa AND CODIGO=@codigo)
				BEGIN       
					INSERT INTO perfil_empleado VALUES (@idperfil,@empresa,@codigo,0,'19000101')
				END
				FETCH NEXT FROM empleadosCursor INTO @codigo,@empresa
            END
        CLOSE empleadosCursor
    DEALLOCATE empleadosCursor

GO 


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'AsignarPerfilEmpleado'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.AsignarPerfilEmpleado
GO

CREATE PROCEDURE [dbo].AsignarPerfilEmpleado
	(@idperfil as bigint,
	 @empresa as bigint,
	 @codigo as bigint)
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY 
    
    declare @existe int
    
    select @existe=COUNT(codigo)
    from perfil_empleado
    where idPerfil=@idperfil
    and empresa=@empresa
    and codigo=@codigo 
    
    if @existe=0 
		begin		
			INSERT INTO perfil_empleado
				   (idPerfil
				   ,empresa
				   ,codigo)
			 VALUES
				   (@idperfil
				   ,@empresa
				   ,@codigo)
		end
GO  

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'EliminaPerfilEmpleado'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.EliminaPerfilEmpleado
GO

CREATE PROCEDURE [dbo].EliminaPerfilEmpleado
	(@idperfil as bigint,
	 @empresa as bigint,
	 @codigo as bigint)
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
		
	DELETE FROM perfil_empleado
    WHERE
       idperfil=@idperfil and 
       empresa=@empresa and 
       codigo=@codigo
GO 

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'EliminaTodoPerfilEmpleado'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.EliminaTodoPerfilEmpleado
GO

CREATE PROCEDURE [dbo].EliminaTodoPerfilEmpleado
	(@idperfil as bigint)
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
		
	DELETE FROM perfil_empleado
    WHERE
       idperfil=@idperfil
GO 


if exists (select * from dbo.sysobjects where id = object_id(N'dbo.permisoEmpleadoPerfil') and xtype in (N'FN', N'IF', N'TF'))
	drop procedure dbo.permisoEmpleadoPerfil
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'permisoEmpleadoPerfil'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.permisoEmpleadoPerfil
GO

CREATE PROCEDURE permisoEmpleadoPerfil
(
	@empresa as bigint,
	@codigo as bigint,
	@funcion as varchar(2),
	@opcion as varchar(2)
)

AS
BEGIN
	-- Declare the return variable here
	DECLARE @Permiso int /* 0 no tiene acceso, 1 si tiene acceso*/
		
	select COUNT(perfil_empleado.codigo) 
	from	perfiles  
		inner join perfil_empleado on perfiles.idperfil= perfil_empleado.idperfil				
		inner join perfil_funcion  on perfiles.idperfil=  perfil_funcion.idperfil
	where perfiles.sistema='TP'
		and perfil_funcion.opcion	= @opcion
		and perfil_funcion.Funcion	= @funcion
		and perfil_empleado.codigo	= @codigo
		and perfil_empleado.empresa	= @empresa


END
GO

/*-----------------------------------------------------------------------------------*/
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosCargaEmpleados'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosCargaEmpleados
GO

CREATE Procedure dbo.usuariosCargaEmpleados
	(@estatusEmpleado as VARCHAR(1),
	 @idEmpresa as bigint)
AS 
    BEGIN
   
    declare @selectClause as varchar(1024)
    declare @fromClause as varchar(1024)
    declare @WhereClause as varchar(1024)
    declare @OrderByClause as varchar(1024)  
    
	set @selectClause = ' Select e.empresa, 
						  e.codigo, 
						  rtrim(e.nombre) + '' '' + rtrim(e.ap_paterno) + '' '' + rtrim(e.ap_materno), 
						  t.actividad, 
						  c.centro,
						  c.nomdepto, 
						  ll.clase,
						  clases.nombre,
						  case e.activo when ''S'' then ''Activo'' else ''Baja'' end as estatus,
						  isnull(d.email,'''') as email '
    					
	set @FromClause =	' From empleados e
						  inner join llaves ll on e.empresa=ll.empresa and e.codigo=ll.codigo
						  inner join tabulador t on e.empresa=t.empresa and ll.ocupacion=t.ocupacion
						  inner join centros c on e.empresa=c.empresa and ll.centro=c.centro
						  inner join clases clases on e.empresa=clases.empresa and clases.clase=ll.clase
						  left join datosemps d on e.empresa=d.empresa and e.codigo=d.codigo '
	
	set @OrderByClause =' Order by e.empresa, e.codigo	'	
	
	set @WhereClause =  ' where	e.codigo>0 '
	
	if @estatusEmpleado='1'--altas
		begin
			set @WhereClause =  @WhereClause + ' and e.activo = ''S'' '  
		end
		
	if @estatusEmpleado='2'--bajas
		begin
			set @WhereClause =  @WhereClause + ' and e.activo = ''N'' ' 
		end	
				
	if @idEmpresa<>0
		begin
			set @WhereClause = @WhereClause + ' and e.empresa= ' + CONVERT(varchar(10),@idEmpresa)  
		end				
				    
    exec  (@selectClause + @fromClause + @whereClause + @orderbyClause)
 
	END  
GO
/*----------------------------------------------------------------------*/


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosEmpleadosAsignadosAPerfil'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosEmpleadosAsignadosAPerfil
GO


CREATE Procedure dbo.usuariosEmpleadosAsignadosAPerfil
	(			
		@idPerfil bigint,
		@idEmpresa bigint
	) 

AS 
    BEGIN
    
	declare @selectClause as varchar(1024)
    declare @fromClause as varchar(1024)
    declare @WhereClause as varchar(1024)
    declare @OrderByClause as varchar(1024)  
    
	set @selectClause =' Select	e.empresa, 
							e.codigo, 
							rtrim(e.nombre) + '' '' + rtrim(e.ap_paterno) + '' '' + rtrim(e.ap_materno), 
							t.actividad, 
							c.centro,
							c.nomdepto, 
							ll.clase,
							clases.nombre,
							case e.activo when ''S'' then ''Activo'' else ''Baja'' end as estatus,
							isnull(d.email,'''') as email'
							
	set @fromClause = ' From empleados e
						inner join llaves ll on e.empresa=ll.empresa and e.codigo=ll.codigo
						inner join tabulador t on e.empresa=t.empresa and ll.ocupacion=t.ocupacion
						inner join centros c on e.empresa=c.empresa and ll.centro=c.centro
						left join datosemps d on e.empresa=d.empresa and e.codigo=d.codigo
						inner join clases clases on e.empresa=clases.empresa and clases.clase=ll.clase
						left join perfil_empleado pe on pe.codigo= e.codigo and pe.empresa = e.empresa'
		
	set @WhereClause =' WHERE PE.idPerfil=' + convert(varchar(10),@idPerfil)		
			
		if @idEmpresa<>0
			begin
				set @WhereClause = @WhereClause + ' and e.empresa= ' + convert(varchar(10),@idEmpresa)		
			end
	
	set @OrderByClause =' order by e.empresa, e.codigo '	
			
	exec (@selectClause + @fromClause + @whereClause + @orderbyClause)
		
	END  
GO
 
if not exists (SELECT distinct(c.name)  
                  FROM dbo.SYSCOLUMNS C  
                  INNER JOIN dbo.SYSOBJECTS T   
                  ON C.[ID] = T.[ID]   
                  WHERE T.XTYPE = 'U'   
                  and t.name='usuarios'   
                  and c.name='fechaAlta')  
  ALTER TABLE usuarios add fechaAlta datetime null 
go

Update usuarios 
set fechaAlta = '19000101'
where fechaalta is null
go

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'InsertaBitacora2'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.InsertaBitacora2
GO

create PROCEDURE dbo.InsertaBitacora2
	@empresa VARCHAR(2) ,
	@hora VARCHAR(20) ,
	@funcion VARCHAR(20) ,
	@codigo bigint ,
	@opcion VARCHAR(20),
	@opcion2 VARCHAR(20),
	@opcion3 VARCHAR(20),
	@usuario VARCHAR(20),
	@clave VARCHAR(20),
	@registroPatronal VARCHAR(20),
	@sistema varchar(2)

AS
SET NOCOUNT ON
SET DATEFORMAT MDY

Insert into bitacora ( empresa
					   ,fecha
					   ,hora
					   ,funcion
					   ,codigo
					   ,opcion
					   ,opcion2
					   ,opcion3
					   ,usuario
					   ,clave
					   ,regpat
					   ,sistema)
values (
		@empresa ,
		GETDATE(),
		@hora ,
		@funcion,
		@codigo,
		@opcion,
		@opcion2,
		@opcion3,
		@usuario,
		@clave,
		@registroPatronal,
		@sistema)

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'LlenaIndicacionesUsuarios'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.LlenaIndicacionesUsuarios
GO

CREATE PROCEDURE [dbo].LlenaIndicacionesUsuarios
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
	
	SELECT Longitud_password,Requiere_numeros 
	FROM ctrl_usuarios
		
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'configuracionUsuarios'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.configuracionUsuarios
GO

CREATE PROCEDURE [dbo].configuracionUsuarios
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
	
	SELECT Dias_vigencia
		  ,Longitud_password
		  ,Rotacion_password
		  ,Requiere_numeros
		  ,Dias_aviso
	FROM ctrl_usuarios
		
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'actualizaConfiguracionUsuarios'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.actualizaConfiguracionUsuarios
GO

CREATE PROCEDURE [dbo].actualizaConfiguracionUsuarios
	(@DiasVigencia bigint,
	@longitud bigint,
	@rotacion bigint,
	@numerosRequeridos bigint,
	@diasAviso bigint)
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
	
	UPDATE Ctrl_usuarios
	SET Dias_vigencia = @DiasVigencia
	  ,Longitud_password = @longitud
	  ,Rotacion_password = @rotacion
	  ,Requiere_numeros = @numerosRequeridos
	  ,Dias_aviso = @diasAviso
		
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CargarEmpresas'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CargarEmpresas
GO

CREATE PROCEDURE [dbo].CargarEmpresas
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
	
	select empresa,nombre_empresa
	from empresas
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CargarSistemas'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CargarSistemas
GO

CREATE PROCEDURE [dbo].CargarSistemas
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
	
	select sistema, nombre
	from Sistema
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CargarFunciones'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CargarFunciones
GO

CREATE PROCEDURE [dbo].CargarFunciones
	(@sistema varchar(3))
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
	
	if @sistema='TODOS'
		Select fUNCION 	from FUNCIONES 
	else
		Select fUNCION 	from FUNCIONES 	WHERE SISTEMA=@sistema
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CargarPerfiles'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CargarPerfiles
GO

CREATE PROCEDURE [dbo].CargarPerfiles
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
    
    Select p.idPerfil, p.Descripcion, s.nombre, p.actualizar, p.sueldo  
    from perfiles p, sistema s
    where p.sistema=s.sistema
		
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'ValidaPerfilEnUSuario'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.ValidaPerfilEnUSuario
GO

CREATE PROCEDURE [dbo].ValidaPerfilEnUSuario
	(@idPerfil bigint)
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
	
	delete from perfil_funcion where idPerfil=@idPerfil
    delete from perfil_centro where idPerfil=@idPerfil
    delete from perfiles where idPerfil=@idPerfil
		
GO


 
IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'CargarPerfilesDeUsuario'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.CargarPerfilesDeUsuario
GO

CREATE PROCEDURE [dbo].CargarPerfilesDeUsuario
	(@usuario as varchar(50))
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
	
	Select s.nombre, pu.idPerfil, p.Descripcion  
    from perfil_usuarios pu, perfiles p, sistema s
    where pu.idperfil=p.idperfil 
    and p.sistema=s.sistema
    and pu.usuario=@usuario
		
GO            

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'AsignarPerfilUsuario'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.AsignarPerfilUsuario
GO

CREATE PROCEDURE [dbo].AsignarPerfilUsuario
	(@usuario as varchar(50),
	@idperfil as bigint)
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
	
	Insert into perfil_usuarios (idPerfil, usuario) 
	values (@idperfil,@usuario )
		
GO  

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'obtenClaveSistema'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.obtenClaveSistema
GO

CREATE PROCEDURE [dbo].obtenClaveSistema
	(@nombre as varchar(50))
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
	
	Select sistema 
	from sistema 
	where nombre=@nombre
		
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'obtenNombreSistema'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.obtenNombreSistema
GO

CREATE PROCEDURE [dbo].obtenNombreSistema
	(@sistema as varchar(50))
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
	
	if @sistema='0'
		Select Nombre from sistema
	else
		Select Nombre from sistema where sistema=@sistema
	
		
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'obtenEmpresasSegunPerfil'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.obtenEmpresasSegunPerfil
GO

CREATE PROCEDURE [dbo].obtenEmpresasSegunPerfil
	(@idPerfil as bigint)
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
    
    declare @lista varchar(300)
	
	Select @lista = empresas
	from perfiles 
	where idPerfil=@idPerfil
	
	if len(@lista)>2
		begin
			set @lista = SUBSTRING(@lista,2,len(@lista)-2)

			select empresa 
			from empresas
			where empresa in (@lista)
		end	
	else
		select 0 from empresas		

GO                         

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'obtenNominaSegunPerfil'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.obtenNominaSegunPerfil
GO

CREATE PROCEDURE [dbo].obtenNominaSegunPerfil
	(@idPerfil as bigint)
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
    
    declare @lista varchar(300)
	
	Select @lista = nomina
	from perfiles 
	where idPerfil=@idPerfil
	
	if len(@lista)>2
		begin
			set @lista = SUBSTRING(@lista,2,len(@lista)-2)

			select distinct(tiponom), nomina 
			from nominas 			
			where tiponom in (@lista)			
		end	
	else
		select 0 from empresas		

GO                         

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'obtenReportesSegunPerfil'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.obtenReportesSegunPerfil
GO

CREATE PROCEDURE [dbo].obtenReportesSegunPerfil
	(@idPerfil as bigint)
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
    
	Select reporte, empresa 
	from perfil_reporte 
	where idPerfil=@idPerfil

GO  

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'obtenCentrosSegunPerfil'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.obtenCentrosSegunPerfil
GO

CREATE PROCEDURE [dbo].obtenCentrosSegunPerfil
	(@idPerfil as bigint)
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
    
	Select isnull(centro,'')
	from perfil_centro
	where idPerfil=@idPerfil

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'borraOpcionesFuncion'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.borraOpcionesFuncion
GO

CREATE PROCEDURE [dbo].borraOpcionesFuncion
	(@funcion as varchar(10),
	 @idperfil as bigint)
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
    
	delete from perfil_funcion where 
    funcion = @funcion
    and idPerfil=@idperfil

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'reporteBitacoraPorUsuario'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.reporteBitacoraPorUsuario
GO

CREATE PROCEDURE dbo.reporteBitacoraPorUsuario
	(@usuario as varchar(50),
	 @sistema as varchar(6),
	 @funcion as varchar(6),
	 @fechaDe as datetime,
	 @fechaA as datetime)
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
    
             
    declare @selectClause as varchar(1024)
    declare @fromClause as varchar(1024)
    declare @WhereClause as varchar(1024)
    declare @OrderByClause as varchar(1024)
    
	set @selectClause = 'SELECT
						convert(varchar(10),fecha,103) as fecha,
						bitacora.hora,
						bitacora.funcion,
						funciones.descripcion,
						bitacora.opcion,
						bitacora.opcion2,
						bitacora.opcion3,
						bitacora.codigo,
						bitacora.usuario,
						sistema.nombre,
						BITACORA.EMPRESA' 
						
	set @fromClause = ' FROM
						bitacora LEFT OUTER JOIN sistema sistema ON
							bitacora.sistema = sistema.sistema
						left join funciones on bitacora.sistema=funciones.sistema 
											and bitacora.funcion=funciones.funcion
											'
	set @whereClause = ' WHERE
							bitacora.fecha >= ''' + convert(varchar(10),@fechade,112)  + ''' AND
							bitacora.fecha <= ''' + convert(varchar(10),@fechaA,112) + ''''
							
	if  @sistema <>'TODOS'
		begin
			set @WhereClause = @whereclause + ' and sistema.sistema='''  + @sistema + ''''
		end
		
	if  @usuario <>'TODOS'
		begin
			set @WhereClause = @whereclause + ' and bitacora.usuario='''  + @usuario + ''''
		end

	if @funcion<>'TODOS'
			set @whereClause = @whereClause + ' and bitacora.funcion=''' + @funcion + '''' 
				
								
	set @OrderByClause = ' ORDER BY
							bitacora.usuario ASC,
							bitacora.sistema ASC '
							
	exec (@selectClause + @fromClause + @whereClause + @OrderByClause)
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'reporteUsuarioExpiracion'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.reporteUsuarioExpiracion
GO

CREATE PROCEDURE [dbo].reporteUsuarioExpiracion
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
    
	SELECT usuario,
		    descripcion,
		   convert(varchar(10),expiracion,103) as fecha,
		   convert(varchar(10),fechaCambio,103) as fechacambio,
		    motivoCambio 		
	FROM usuarios
	order by usuario
GO



IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'reporteUsuarioAltas'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.reporteUsuarioAltas
GO

CREATE PROCEDURE dbo.reporteUsuarioAltas
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
    
	SELECT  usuario,
		    descripcion,
		    fechaAlta,
		    fechaCambio,
		    motivoCambio 		
	FROM usuarios
	order by usuario
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'reporteBitacoraPorFuncion'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.reporteBitacoraPorFuncion
GO

CREATE PROCEDURE [dbo].reporteBitacoraPorFuncion
	(@idempresa as bigint,
	 @sistema as varchar(5),
	 @funcion as varchar(10),
	 @fechaDe as datetime,
	 @fechaA as datetime)
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    
    declare @selectClause as varchar(1024)
    declare @fromClause as varchar(1024)
    declare @WhereClause as varchar(1024)
    declare @OrderByClause as varchar(1024)  
    
	set @selectClause = ' SELECT
							convert(decimal(9,0),empresas.empresa) as empresa,
							empresas.nombre_empresa,
							convert(varchar(10),bitacora.fecha,103) as fecha,
							bitacora.hora,
							bitacora.funcion,
							bitacora.opcion,
							bitacora.opcion2,
							bitacora.opcion3,
							bitacora.usuario,
							BITACORA.CODIGO,
							bitacora.sistema,
							sistema.nombre'
	set @fromClause   = ' FROM
							(empresas empresas LEFT OUTER JOIN bitacora bitacora ON
								empresas.empresa = bitacora.empresa)
							LEFT OUTER JOIN Sistema sistema ON
								bitacora.sistema = sistema.sistema'
	set @whereClause  = ' WHERE
						bitacora.fecha >= ''' +  convert(varchar(10),@fechade,112)  + ''' AND
						bitacora.fecha <= ''' +  convert(varchar(10),@fechaA,112) + ''''
	
	if @idempresa<>'0'
		begin
			set @whereClause = @whereClause + ' and empresas.empresa=' + CONVERT(varchar(8),@idempresa)
		end	
		
	if @sistema<>'TODOS'
		begin
			set @whereClause = @whereClause + ' and bitacora.sistema =''' + @sistema + ''''
		end	
		
	if @funcion<>'TODOS'
		begin
			if @sistema='NO' and substring(@funcion,1,1)='X'
				set @whereClause = @whereClause + ' and bitacora.funcion=''X'''
			else
				set @whereClause = @whereClause + ' and bitacora.funcion=''' + @funcion + '''' 
		end									
						
						
	set @orderbyClause = ' ORDER BY
						empresas.nombre_empresa ASC,
						bitacora.sistema ASC,
						bitacora.funcion ASC'
						
	EXEC  (@selectClause + @fromClause + @whereClause + @orderbyClause)
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'reporteFuncionesOpcionesPorSistema'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.reporteFuncionesOpcionesPorSistema
GO

CREATE PROCEDURE [dbo].reporteFuncionesOpcionesPorSistema
( @sistema as varchar(2))
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
            
    declare @selectClause as varchar(1024)
    declare @fromClause as varchar(1024)
    declare @WhereClause as varchar(1024)
    
	set @selectClause = ' SELECT	sistema.sistema, 
						sistema.nombre,
						funciones.funcion,
						funciones.descripcion as nombreFuncion,
						opciones.opcion,
						opciones.descripcion as nombreOpcion'					
	set @FROMClause = ' FROM funciones, opciones, sistema'
	set @WHEREClause = ' where sistema.sistema=funciones.sistema
						and sistema.sistema=opciones.sistema						
						and funciones.funcion=opciones.funcion'
						
	if  @sistema <>''
		begin
			set @WhereClause = @whereclause + ' and sistema.sistema='''  + @sistema + ''''
		end
						
	EXEC (@selectClause + @fromClause + @whereClause)

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'nuevoPerfil'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.nuevoPerfil
GO

CREATE PROCEDURE dbo.nuevoPerfil
	(  @descripcion as varchar(30),
	   @sistema as varchar(2),
	   @actualizar as char(1),
	   @sueldo as char(1))
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY  
            
	INSERT INTO perfiles
           (descripcion
           ,sistema
           ,empresas
           ,nomina
           ,actualizar
           ,sueldo)
     VALUES
           (@descripcion
           ,@sistema
           ,'{}'
           ,'{}'
           ,@actualizar
           ,@sueldo)
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'actualizaPerfil'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.actualizaPerfil
GO

CREATE PROCEDURE dbo.actualizaPerfil
	(   @idPerfil as bigint,
		@descripcion as varchar(30),
		@sistema as varchar(2),
		@empresas as varchar(300),
		@nomina as varchar(15),
		@actualizar as char(1),
		@sueldo as char(1))
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY 
    
    UPDATE dbo.perfiles
	SET [descripcion] = @descripcion
       ,[sistema] = @sistema
       ,[empresas] = @empresas
       ,[nomina] = @nomina
       ,[actualizar] = @actualizar
       ,[sueldo] = @sueldo
	WHERE idperfil=@idPerfil
            
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'eliminarPerfil'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.eliminarPerfil
GO

CREATE PROCEDURE dbo.eliminarPerfil
	(@idPerfil as bigint)
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY 

	delete from perfil_funcion where idPerfil=@idPerfil
    delete from perfil_centro  where idPerfil=@idPerfil
    delete from perfiles where idPerfil=@idPerfil
    delete from perfil_empleado where idPerfil=@idPerfil
                
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'actualizaFEchaAlta'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.actualizaFEchaAlta
GO
CREATE PROCEDURE [dbo].[actualizaFEchaAlta]

AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY 
    declare @dias as bigint
    
    select @dias=Dias_vigencia
    from Ctrl_usuarios
    
	update usuarios set fechaAlta= (expiracion-@dias)
	where fechaAlta ='19000101'
           
GO

exec actualizaFEchaAlta
go


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosRevisaIntentosEmpleado'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosRevisaIntentosEmpleado
GO
create PROCEDURE dbo.usuariosRevisaIntentosEmpleado
(@empleado bigint, 
 @empresa bigint,
 @password varchar(30),
 @sistema char(2))
AS
     SET NOCOUNT ON
     SET DATEFORMAT MDY
     SET XACT_ABORT ON
     BEGIN TRANSACTION

	 BEGIN TRY

	declare @intentosPermitidos int
	declare @tiempoDeBloqueo datetime

	declare @EstaBloqueado int
	declare @horaDeBloqueo datetime

	declare @Resultado int
	declare @usuarioValido int
	declare @intentosEnTemporal int
	declare @ultimoIntento datetime

	declare @minutosLlevaBloqueado bigint
	declare @MOTIVO VARCHAR(15)

	set @resultado=1
	set @usuarioValido = 0

	select @intentosPermitidos=intentos, @tiempoDeBloqueo=tiempoDeBloqueo
	from ctrl_usuarios

	if @intentosPermitidos>0
		Begin

			Select @EstaBloqueado=bloqueadoporintentos,@horaDeBloqueo=HoraDeBloqueo
			from usuarios
			where usuario=@empleado

			select @minutosLlevaBloqueado=datediff(minute, @horaDeBloqueo,getdate())

			if @EstaBloqueado= 1
				begin
					if @minutosLlevaBloqueado<=@tiempoDeBloqueo
			 			--bloqueado sin tiempo transcurrido
						begin
							set @resultado=5
						end
					if @minutosLlevaBloqueado>@tiempoDeBloqueo
						--revisar la hora del ultimo intento y si ya pas lo reglamentario borrar registros, si no esperar mas.
						begin
							update usuarios set BloqueadoPorIntentos=0, HoraDeBloqueo='19000101' where usuario=@empleado
							delete from UsuariosTemporalRegistro 
							where usuario=@empleado
							and sistema=@sistema
						end
				end

			if @EstaBloqueado=0
				begin
					insert into UsuariosTemporalRegistroEmpleado(empleado,empresa,horaRegistro, sistema)
					values (@empleado, @empresa, getdate(),@sistema)

					select @intentosEnTemporal=count(*)
					from UsuariosTemporalRegistroEmpleado 
					where empleado=@empleado
					and sistema=@sistema
					and empresa=@empresa

					if @intentosEnTemporal>@intentosPermitidos
						begin
							--excede el limite permitido 
							set @resultado=9
							update perfil_empleado 
								set bloqueado=1 , 
								horaBloqueo=getdate()
								where codigo=@empleado
								and empresa=@empresa

						end

					if @intentosEnTemporal<=@intentosPermitidos
						-- puede pasar
						begin
							set @resultado=1
						end
				end
		End

	select @usuarioValido=count(*) 
	from usuarios 
	where usuario=@empleado
	and password=@password

	if @usuarioValido>0
		begin	
			Select @MOTIVO=motivocambio 
			from usuarios
			WHERE USUARIO=@empleado

			IF @MOTIVO='Desactivado'
				SET @usuarioValido=2

		end

	select @usuarioValido, @resultado from Ctrl_usuarios


	  END TRY
     BEGIN CATCH

         IF ( XACT_STATE() ) = -1
             OR @@TRANCOUNT > 0
             ROLLBACK TRANSACTION

         SELECT  ERROR_NUMBER() AS ErrorNumber ,
                 ERROR_SEVERITY() AS ErrorSeverity ,
                 ERROR_STATE() AS ErrorState ,
                 ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                 ERROR_LINE() AS ErrorLine ,
                 ERROR_MESSAGE() AS ErrorMessage

     END CATCH

     IF @@TRANCOUNT > 0
         COMMIT TRANSACTION        
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosReporteEquipos'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosReporteEquipos
GO
CREATE PROCEDURE [dbo].[usuariosReporteEquipos]

AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY 
    
    select *
    from NOM_TBL_Equipo
	order by ip
    
GO




IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosDetalleUsuario'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosDetalleUsuario
GO
create PROCEDURE dbo.usuariosDetalleUsuario
( @idusuario varchar(50))
AS
BEGIN 
	Select  usuario,
			descripcion,
			password,
			convert(varchar(10),expiracion,112) as expiracion,
			isnull(email,'') as email,
			convert(varchar(10),fechacambio,112) as fechacambio,
			isnull(motivocambio,'') as motivocambio
	from usuarios 
	where usuario=@idUsuario
	
END
            
go

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosEmpresasPorPerfil'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosEmpresasPorPerfil
GO
create PROCEDURE dbo.usuariosEmpresasPorPerfil
(   @idPerfil bigint,
	@listaempresas varchar(650))

AS
BEGIN 
	
	declare @consulta as varchar(max)
	set @consulta =' SELECT empresa,
					nombre_empresa,
					registro_patronal, 
					idperfil, 
					descripcion, 
					rfc_empresa
					from perfiles, empresas 
					where empresa in (' + @listaempresas + ') and idperfil=' + convert(varchar(10),@idPerfil) 
	exec (@consulta)
	
END
            
go


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosCentroCostosListadoPerfiles'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosCentroCostosListadoPerfiles
GO
create PROCEDURE dbo.usuariosCentroCostosListadoPerfiles

AS
BEGIN 

	select distinct(c.centro), c.nomdepto, c.empresa,empresas.referencia
	from centros c
	inner join empresas on empresas.empresa=c.empresa
	order by c.empresa, c.centro

END
            
go

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosCentroCostosListadoPerfilesActivos'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosCentroCostosListadoPerfilesActivos
GO
create PROCEDURE dbo.usuariosCentroCostosListadoPerfilesActivos
(@empresa as bigint)
AS
BEGIN 

	select '', c.centro, c.nomdepto, c.empresa, rtrim(empresas.nombre_empresa) + ' ' + rtrim(empresas.referencia)
	from centros c
	inner join Llaves ll on ll.empresa=c.empresa and ll.centro=c.centro
	inner join empleados emp on emp.empresa=ll.empresa and emp.codigo=ll.codigo
	inner join empresas on empresas.empresa=emp.empresa
	where emp.activo='S' and emp.ultmov<>'B'
	and IIF(@empresa<>0,ll.empresa,0)=IIF(@empresa<>0,@empresa,0)
	group by c.centro, c.nomdepto, c.empresa, rtrim(empresas.nombre_empresa) + ' ' + rtrim(empresas.referencia)
	order by c.empresa, c.centro

END
            
go

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosCentrosLlenar'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosCentrosLlenar
GO

create PROCEDURE dbo.usuariosCentrosLlenar
(@empresa as bigint)
AS
	BEGIN 

		SELECT  '', 
				c.centro, 
				c.nomdepto,
				c.empresa,
				rtrim(e.nombre_empresa) + ' ' + rtrim(e.referencia) as nombre
		FROM centros c
			left join empresas e on e.empresa=c.empresa  
		where c.centro<>'99999999999997'
			and c.centro<>''
			and IIF(@empresa<>0,c.empresa,0)=IIF(@empresa<>0,@empresa,0)
			


	END           
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosCentrosLlenarPerfil'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosCentrosLlenarPerfil
GO

create PROCEDURE dbo.usuariosCentrosLlenarPerfil
(@empresa as bigint,
@idperfil as bigint)
AS
	BEGIN 

	
		SELECT  pc.centro, 
				pc.empresa
		FROM perfil_centro pc 
		where IIF(@empresa<>0,pc.empresa,0)=IIF(@empresa<>0,@empresa,0)
			and pc.idperfil=@idperfil
			and pc.centro<>'99999999999997'
			and pc.centro<>''

	END           
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosFuncionesLlenar'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosFuncionesLlenar
GO

create PROCEDURE dbo.usuariosFuncionesLlenar
(@idPerfil as bigint)
AS

	BEGIN 
		Select funcion 
		from perfil_funcion 
		where idPerfil = @idPerfil
	END
            
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosEmpresasLlenar'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosEmpresasLlenar
GO

create PROCEDURE dbo.usuariosEmpresasLlenar
(@idPerfil as bigint)
AS

	BEGIN 
	set nocount on
	CREATE TABLE #temp_results (EMPRESA BIGINT)

	INSERT INTO #temp_results
	select VALUE 
	from perfiles p
	cross apply STRING_SPLIT(SUBSTRING(p.empresas,2,LEN(p.empresas)-2), ',') 
	where p.idperfil=@idperfil

	select  CASE ISNULL(T.EMPRESA,0)
			WHEN 0 THEN ''
			ELSE ' ' END AS EXISTE,
			e.EMPRESA,
		   rtrim(e.nombre_empresa) + ' - ' + rtrim(e.referencia),
		   e.registro_patronal
	from empresas e
		FULL OUTER JOIN #temp_results T ON T.EMPRESA=e.empresa

	DROP TABLE #temp_results
	END
            
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosEliminaUsuario'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosEliminaUsuario
GO

create PROCEDURE dbo.usuariosEliminaUsuario
(@usuario as varchar(30))
AS

	BEGIN 
		Delete from hpwd where usuario=@usuario
		Delete from perfil_usuarios where usuario=@usuario
		Delete from usuarios where usuario=@usuario
	END
            
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosPerfilCargaDetalle'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosPerfilCargaDetalle
GO

create PROCEDURE dbo.usuariosPerfilCargaDetalle
(@idPerfil as bigint)
AS

	BEGIN 
		Select p.idPerfil,
				p.Descripcion, 
				s.nombre, 
				p.actualizar, 
				p.sueldo, 
				s.sistema  
        from perfiles p
		 left join sistema s on p.sistema=s.sistema
        where p.sistema=s.sistema 
		and idPerfil=@idPerfil
	
	END
            
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosPermisoModuloUsuario'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosPermisoModuloUsuario
GO

create PROCEDURE dbo.usuariosPermisoModuloUsuario
(@usuario as varchar(30))
AS

	BEGIN 
		select COUNT(*) 
		from perfil_usuarios 
			left join usuarios on perfil_usuarios.usuario=usuarios.usuario
		where perfil_usuarios.idperfil in (select idperfil from perfiles where sistema='US') 
			and usuarios.usuario=@usuario
	END
            
GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.usuariosNominaCambiaKZ')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.usuariosNominaCambiaKZ
GO

CREATE PROCEDURE dbo.usuariosNominaCambiaKZ

AS 
	BEGIN

	create table #Temporal (idPerfil bigint,
							opcion varchar(3))
	
	create table #TemporalPerfiles (idPerfil bigint)						

	insert into #TemporalPerfiles 
	select perfiles.idperfil
	from perfiles
	where perfiles.sistema='NO'

	delete from opciones where sistema='NO' and funcion ='K' and opcion='2' 
	delete from opciones where sistema='NO' and funcion ='K' and opcion='13' 
	delete from perfil_funcion where funcion='K' and opcion='2' and idperfil in (select idperfil from #TemporalPerfiles)
	delete from perfil_funcion where funcion='K' and opcion='13' and idperfil in (select idperfil from #TemporalPerfiles)

	if not exists (select * from opciones where opcion='7' and sistema='NO' and funcion='Z')
	begin
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('7','NO','Z','Archivos SAT Altas y Validaciones')
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('8','NO','Z','Sub-Contratacin')
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('9','NO','Z','Forma 37 De Otros Patrones')
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('10','NO','Z','Auditor Fiscal')
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('11','NO','Z','Reportes Auxiliares')
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('12','NO','Z','Ajuste Anual')
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('13','NO','Z','Calcular RFC / CURP')
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('14','NO','Z','Simuladores de ISR')
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('15','NO','Z','Catlogos Nmina Digital')
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('16','NO','Z','Visor CFDIs')
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('17','NO','Z','Leyes y reglamentos SAT')
		
		DECLARE @idPerfil AS bigint

		DECLARE Perfiles CURSOR FOR SELECT idperfil FROM #TemporalPerfiles

		OPEN Perfiles

		FETCH NEXT FROM Perfiles INTO @idPerfil

		WHILE @@fetch_status = 0

		BEGIN

			insert into #Temporal values( @idPerfil,'7')
			insert into #Temporal values( @idPerfil,'8')
			insert into #Temporal values( @idPerfil,'9')
			insert into #Temporal values( @idPerfil,'10')
			insert into #Temporal values( @idPerfil,'11')
			insert into #Temporal values( @idPerfil,'12')
			insert into #Temporal values( @idPerfil,'13')
			insert into #Temporal values( @idPerfil,'14')
			insert into #Temporal values( @idPerfil,'15')
			insert into #Temporal values( @idPerfil,'16')
			insert into #Temporal values( @idPerfil,'17')
		
			FETCH NEXT FROM Perfiles INTO @idPerfil
		END

		CLOSE Perfiles

		DEALLOCATE Perfiles

		insert into perfil_funcion 
		SELECT 'Z',opcion,idPerfil from #Temporal
	END
end 
Go


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.usuariosReportesTabla')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.usuariosReportesTabla
GO

CREATE PROCEDURE dbo.usuariosReportesTabla
(@empresa as bigint)
AS 
	BEGIN
		SELECT f.nombre, f.empresa,  rtrim(e.nombre_empresa) +' ' + rtrim(e.referencia) 
		FROM Gr_Formas f
			left join empresas e on f.empresa=e.empresa
		where f.Campo = 'CONTROL' 		
		and IIF(@empresa<>0,e.empresa,0)=IIF(@empresa<>0,@empresa,0) 
		order by f.empresa, f.nombre
end 
Go


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'usuariosTipoNominaLlenar'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.usuariosTipoNominaLlenar
GO

create PROCEDURE dbo.usuariosTipoNominaLlenar
(@idPerfil as bigint)
AS

	BEGIN 
	set nocount on
	CREATE TABLE #temp_results (tipoNomina BIGINT)

	INSERT INTO #temp_results
	select VALUE 
	from perfiles p
	cross apply STRING_SPLIT(SUBSTRING(p.nomina,2,LEN(p.nomina)-2), ',') 
	where p.idperfil=@idperfil

	select  distinct CASE (ll.tiponom)
			WHEN 0 THEN ''
			ELSE ' ' END AS EXISTE,
			ll.tiponom, 
			case Ll.tiponom
			when 1 then 'SEMANAL'
			when 2 then 'DECENAL'
			when 3 then 'CATORCENAL'
			when 4 then 'QUINCENAL'
			when 5 then 'MENSUAL'
			when 6 then 'ESPECIAL' end AS NombreTN
	from llaves ll
		FULL OUTER JOIN #temp_results T ON T.tipoNomina=ll.tiponom
	where ll.tiponom is not null
	group by ll.tiponom
	DROP TABLE #temp_results
	END
            
GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.usuariosReportesListadoAnt')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.usuariosReportesListadoAnt
GO

CREATE PROCEDURE dbo.usuariosReportesListadoAnt
(@idPerfil bigint,
@empresa bigint)
AS 
	BEGIN

	Select pr.reporte, pr.empresa, rtrim(e.nombre_empresa) +' ' + rtrim(e.referencia)
	from perfil_reporte pr
		left join empresas e on e.empresa=pr.empresa
	where idPerfil=@idPerfil
	and IIF(@empresa<>0,pr.empresa,0)=IIF(@empresa<>0,@empresa,0) 
	order by pr.empresa, pr.reporte

end 
Go
